Solid Example: Cell Selection

import { For, Show, createEffect, createSignal, on } from 'solid-js'
import { faker } from '@faker-js/faker'
import {
  FlexRender,
  cellSelectionFeature,
  columnOrderingFeature,
  columnPinningFeature,
  columnVisibilityFeature,
  createColumnHelper,
  createSortedRowModel,
  createTable,
  rowSortingFeature,
  sortFn_alphanumeric,
  sortFn_datetime,
  sortFn_text,
  tableFeatures,
} from '@tanstack/solid-table'
import { useTanStackTableDevtools } from '@tanstack/solid-table-devtools'
import { createHotkeys } from '@tanstack/solid-hotkeys'
import { makeData } from './makeData'
import type { Cell } from '@tanstack/solid-table'
import type { Person } from './makeData'

const features = tableFeatures({
  cellSelectionFeature,
  columnOrderingFeature,
  columnPinningFeature,
  columnVisibilityFeature,
  rowSortingFeature,
  sortedRowModel: createSortedRowModel(),
  sortFns: {
    alphanumeric: sortFn_alphanumeric,
    datetime: sortFn_datetime,
    text: sortFn_text,
  },
})

const columnHelper = createColumnHelper<typeof features, Person>()

// Serializing a selection for the clipboard is a userland concern: the table
// hands back `getSelectedCellRangesData()` as raw values, and the delimiter,
// the null representation, and the quoting rules are all yours to pick. This is
// the spreadsheet-flavored version.
function escapeTsvValue(value: unknown) {
  const text = value == null ? '' : String(value)
  const safeText =
    typeof value === 'string' && /^[\t\r ]*[=+@-]/.test(value)
      ? `'${text}`
      : text

  // spreadsheets expect a field to be quoted once it contains a delimiter, a
  // newline, or a quote, with inner quotes doubled
  return /["\t\n\r]/.test(safeText)
    ? `"${safeText.replace(/"/g, '""')}"`
    : safeText
}

function toTsv(ranges: Array<Array<Array<unknown>>>) {
  return ranges
    .map((grid) =>
      grid.map((row) => row.map(escapeTsvValue).join('\t')).join('\n'),
    )
    .join('\n\n') // blank line between final selected regions
}

function getCellClassName(cell: Cell<typeof features, Person>) {
  // Most cells in a large grid are unselected, so bail before asking for edges.
  // getSelectionEdges() would otherwise resolve the cell's position a second
  // time just to discover it is not selected.
  if (!cell.getIsSelected()) {
    return cell.getIsFocused()
      ? 'cell-selectable cell-focused'
      : 'cell-selectable'
  }

  const edges = cell.getSelectionEdges()

  return [
    'cell-selectable',
    'cell-selected',
    cell.getIsFocused() && 'cell-focused',
    edges.top && 'cell-edge-top',
    edges.right && 'cell-edge-right',
    edges.bottom && 'cell-edge-bottom',
    edges.left && 'cell-edge-left',
  ]
    .filter(Boolean)
    .join(' ')
}

const columns = columnHelper.columns([
  columnHelper.accessor('firstName', {
    header: 'First Name',
    cell: (info) => info.getValue(),
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor((row) => row.lastName, {
    id: 'lastName',
    header: () => 'Last Name',
    cell: (info) => info.getValue(),
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('age', {
    header: () => 'Age',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('visits', {
    header: () => 'Visits',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('status', {
    header: 'Status',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('progress', {
    header: 'Profile Progress',
    // enableCellSelection: false, // this column opts out of cell selection
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('email', {
    header: 'Email',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('phone', {
    header: 'Phone',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('city', {
    header: 'City',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('country', {
    header: 'Country',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('department', {
    header: 'Department',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('salary', {
    header: 'Salary',
    cell: (info) => info.getValue().toLocaleString(),
    footer: (props) => props.column.id,
  }),
])

function App() {
  const [data, setData] = createSignal(makeData(20))
  const refreshData = () => setData(makeData(20))
  const stressTest = () => setData(makeData(1_000))

  const table = createTable({
    key: 'cell-selection', // needed for devtools
    features,
    get data() {
      return data()
    },
    columns,
    getRowId: (row: Person) => row.id,
    enableCellSelection: true, // enable cell selection for all cells
    // initialState: { cellSelection: [] }, // select cells on first render
    // state: { cellSelection }, // classic controlled state; pair with onCellSelectionChange
    // onCellSelectionChange: setCellSelection,
    // enableCellRangeSelection: false, // disable Shift-click and drag ranges; default true
    // enableMultiCellRangeSelection: false, // allow only one rectangle at a time; default true
    // enableCellSelectionDrag: false, // disable drag-to-select; default true
    // isCellRangeSelectionEvent: event => Boolean(event.metaKey), // use Meta instead of Shift
    debugTable: true,
  })

  useTanStackTableDevtools(table)

  const randomizeColumns = () => {
    table.setColumnOrder(
      faker.helpers.shuffle(table.getAllLeafColumns().map((d) => d.id)),
    )
  }

  // optionally, reset the cellSelection state not only when data changes, but
  // also when column order, pinning, visibility, or sorting changes
  // customize this to your needs. `defer: true` skips the first run so an
  // initialState selection survives mount.
  createEffect(
    on(
      () => [
        table.atoms.columnOrder.get(),
        table.atoms.columnPinning.get(),
        table.atoms.columnVisibility.get(),
        table.atoms.sorting.get(),
      ],
      () => table.resetCellSelection(true),
      { defer: true },
    ),
  )

  let gridRef!: HTMLDivElement

  // keyboard navigation is TanStack Hotkeys driving the table's imperative
  // APIs; table-core ships no keydown handling of its own
  createHotkeys(
    [
      { hotkey: 'ArrowUp', callback: () => table.moveCellSelection('up') },
      { hotkey: 'ArrowDown', callback: () => table.moveCellSelection('down') },
      { hotkey: 'ArrowLeft', callback: () => table.moveCellSelection('left') },
      {
        hotkey: 'ArrowRight',
        callback: () => table.moveCellSelection('right'),
      },
      {
        hotkey: 'Shift+ArrowUp',
        callback: () => table.extendCellSelection('up'),
      },
      {
        hotkey: 'Shift+ArrowDown',
        callback: () => table.extendCellSelection('down'),
      },
      {
        hotkey: 'Shift+ArrowLeft',
        callback: () => table.extendCellSelection('left'),
      },
      {
        hotkey: 'Shift+ArrowRight',
        callback: () => table.extendCellSelection('right'),
      },
      { hotkey: 'Mod+A', callback: () => table.selectAllCells() },
      { hotkey: 'Escape', callback: () => table.resetCellSelection(true) },
      {
        hotkey: 'Mod+C',
        callback: () => {
          void navigator.clipboard.writeText(
            toTsv(table.getSelectedCellRangesData()),
          )
        },
      },
    ],
    () => ({ target: gridRef }),
  )

  return (
    <div class="demo-root">
      <div>
        <button
          class="demo-button demo-button-spaced"
          onClick={() => refreshData()}
        >
          Regenerate Data
        </button>
        <button
          class="demo-button demo-button-spaced"
          onClick={() => stressTest()}
        >
          Stress Test (1K rows)
        </button>
      </div>
      <div class="spacer-sm" />
      <p>
        Click and drag to select a range of cells. Hold Shift while clicking to
        extend the selection, or Ctrl/Cmd to add or subtract a rectangle. Arrow
        keys move the selection, Shift+Arrow extends it, Mod+A selects all,
        Mod+C copies, and Escape clears. Uncomment `enableCellSelection: false`
        on a column def to opt that column out of selection.
      </p>
      <p class="demo-note">
        Hiding, reordering, and pinning columns all keep a live selection
        anchored to the same cell ids. Ranges are indexed in render order, so a
        pinned column moves the rectangle with it rather than splitting it.
      </p>
      <div class="column-toggle-panel">
        <div class="column-toggle-panel-header">
          <label>
            <input
              type="checkbox"
              checked={table.getIsAllColumnsVisible()}
              onChange={table.getToggleAllColumnsVisibilityHandler()}
            />{' '}
            Toggle All
          </label>
        </div>
        <For each={table.getAllLeafColumns()}>
          {(column) => (
            <div class="column-toggle-row">
              <label>
                <input
                  type="checkbox"
                  checked={column.getIsVisible()}
                  onChange={column.getToggleVisibilityHandler()}
                />{' '}
                {column.id}
              </label>
            </div>
          )}
        </For>
      </div>
      <div class="spacer-sm" />
      <div class="button-row">
        <button
          class="demo-button demo-button-spaced"
          onClick={() => randomizeColumns()}
        >
          Shuffle Columns
        </button>
        <button
          class="demo-button demo-button-spaced"
          onClick={() =>
            table.setColumnOrder(
              [
                ...table.getAllLeafColumns().map((column) => column.id),
              ].reverse(),
            )
          }
        >
          Reverse Column Order
        </button>
        <button
          class="demo-button demo-button-spaced"
          onClick={() => table.resetColumnOrder()}
        >
          Reset Column Order
        </button>
        <button
          class="demo-button demo-button-spaced"
          onClick={() => table.resetColumnPinning()}
        >
          Reset Pinning
        </button>
        <button
          class="demo-button demo-button-spaced"
          onClick={() => table.resetColumnVisibility()}
        >
          Reset Visibility
        </button>
      </div>
      <div class="spacer-sm" />
      {/*
        Solid tracks atom reads natively, so this count re-evaluates on its own.
        There is no equivalent of React's per-row Subscribe to reach for here.
      */}
      <div>
        {table.getSelectedCellCount().toLocaleString()} cells selected across{' '}
        {table.getCellSelectionRowIds().length.toLocaleString()} rows and{' '}
        {table.getCellSelectionColumnIds().length} columns
      </div>
      <div class="spacer-sm" />
      <div ref={gridRef} tabindex={0}>
        <table>
          <thead>
            <For each={table.getHeaderGroups()}>
              {(headerGroup) => (
                <tr>
                  <For each={headerGroup.headers}>
                    {(header) => (
                      <th colSpan={header.colSpan}>
                        <Show when={!header.isPlaceholder}>
                          <button
                            type="button"
                            disabled={!header.column.getCanSort()}
                            class={
                              header.column.getCanSort()
                                ? 'header-button sortable-header'
                                : 'header-button'
                            }
                            onClick={header.column.getToggleSortingHandler()}
                          >
                            <FlexRender header={header} />
                            {{ asc: ' 🔼', desc: ' 🔽' }[
                              header.column.getIsSorted() as string
                            ] ?? null}
                          </button>
                          <Show when={header.column.getCanPin()}>
                            <div class="pin-actions">
                              <Show
                                when={header.column.getIsPinned() !== 'start'}
                              >
                                <button
                                  class="pin-button"
                                  onClick={() => header.column.pin('start')}
                                >
                                  {'<='}
                                </button>
                              </Show>
                              <Show when={header.column.getIsPinned()}>
                                <button
                                  class="pin-button"
                                  onClick={() => header.column.pin(false)}
                                >
                                  X
                                </button>
                              </Show>
                              <Show
                                when={header.column.getIsPinned() !== 'end'}
                              >
                                <button
                                  class="pin-button"
                                  onClick={() => header.column.pin('end')}
                                >
                                  {'=>'}
                                </button>
                              </Show>
                            </div>
                          </Show>
                        </Show>
                      </th>
                    )}
                  </For>
                </tr>
              )}
            </For>
          </thead>
          <tbody>
            <For each={table.getRowModel().rows}>
              {(row) => (
                <tr>
                  <For each={row.getVisibleCells()}>
                    {(cell) => (
                      <Show
                        when={cell.getCanSelect()}
                        fallback={
                          <td>
                            <FlexRender cell={cell} />
                          </td>
                        }
                      >
                        <td
                          class={getCellClassName(cell)}
                          tabindex={cell.getTabIndex()}
                          onMouseDown={cell.getSelectionStartHandler()}
                          onMouseEnter={cell.getSelectionExtendHandler()}
                        >
                          <FlexRender cell={cell} />
                        </td>
                      </Show>
                    )}
                  </For>
                </tr>
              )}
            </For>
          </tbody>
          <tfoot>
            <tr>
              <td colSpan={20}>
                Rows ({table.getRowModel().rows.length.toLocaleString()})
              </td>
            </tr>
          </tfoot>
        </table>
      </div>
      <div class="spacer-sm" />
      <div>
        <button
          class="demo-button demo-button-spaced"
          onClick={() =>
            void navigator.clipboard.writeText(
              toTsv(table.getSelectedCellRangesData()),
            )
          }
        >
          Copy Selection
        </button>
        <button
          class="demo-button demo-button-spaced"
          onClick={() => table.selectAllCells()}
        >
          Select All Cells
        </button>
        <button
          class="demo-button demo-button-spaced"
          onClick={() => table.resetCellSelection(true)}
        >
          Clear Selection
        </button>
      </div>
      <hr />
      <br />
      <div>
        <button
          class="demo-button demo-button-spaced"
          onClick={() =>
            console.info(
              'table.getSelectedCellRangesData()',
              table.getSelectedCellRangesData(),
            )
          }
        >
          Log table.getSelectedCellRangesData()
        </button>
      </div>
      <div>
        <label>State:</label>
        <pre>
          {data().length < 1_001
            ? JSON.stringify(table.store.get(), null, 2)
            : ''}
        </pre>
      </div>
      <div>
        <label for="paste-target">Paste Test:</label>
        {/*
          scratch area for pasting a copied selection back in, to eyeball the
          tab-separated shape. It sits outside the grid ref, so the table
          hotkeys never intercept typing or Mod+V in here.
        */}
        <textarea
          id="paste-target"
          class="text-input"
          rows={8}
          placeholder="Copy a selection, then paste here to check the tab-separated output..."
        />
      </div>
    </div>
  )
}

export default App
import { For, Show, createEffect, createSignal, on } from 'solid-js'
import { faker } from '@faker-js/faker'
import {
  FlexRender,
  cellSelectionFeature,
  columnOrderingFeature,
  columnPinningFeature,
  columnVisibilityFeature,
  createColumnHelper,
  createSortedRowModel,
  createTable,
  rowSortingFeature,
  sortFn_alphanumeric,
  sortFn_datetime,
  sortFn_text,
  tableFeatures,
} from '@tanstack/solid-table'
import { useTanStackTableDevtools } from '@tanstack/solid-table-devtools'
import { createHotkeys } from '@tanstack/solid-hotkeys'
import { makeData } from './makeData'
import type { Cell } from '@tanstack/solid-table'
import type { Person } from './makeData'

const features = tableFeatures({
  cellSelectionFeature,
  columnOrderingFeature,
  columnPinningFeature,
  columnVisibilityFeature,
  rowSortingFeature,
  sortedRowModel: createSortedRowModel(),
  sortFns: {
    alphanumeric: sortFn_alphanumeric,
    datetime: sortFn_datetime,
    text: sortFn_text,
  },
})

const columnHelper = createColumnHelper<typeof features, Person>()

// Serializing a selection for the clipboard is a userland concern: the table
// hands back `getSelectedCellRangesData()` as raw values, and the delimiter,
// the null representation, and the quoting rules are all yours to pick. This is
// the spreadsheet-flavored version.
function escapeTsvValue(value: unknown) {
  const text = value == null ? '' : String(value)
  const safeText =
    typeof value === 'string' && /^[\t\r ]*[=+@-]/.test(value)
      ? `'${text}`
      : text

  // spreadsheets expect a field to be quoted once it contains a delimiter, a
  // newline, or a quote, with inner quotes doubled
  return /["\t\n\r]/.test(safeText)
    ? `"${safeText.replace(/"/g, '""')}"`
    : safeText
}

function toTsv(ranges: Array<Array<Array<unknown>>>) {
  return ranges
    .map((grid) =>
      grid.map((row) => row.map(escapeTsvValue).join('\t')).join('\n'),
    )
    .join('\n\n') // blank line between final selected regions
}

function getCellClassName(cell: Cell<typeof features, Person>) {
  // Most cells in a large grid are unselected, so bail before asking for edges.
  // getSelectionEdges() would otherwise resolve the cell's position a second
  // time just to discover it is not selected.
  if (!cell.getIsSelected()) {
    return cell.getIsFocused()
      ? 'cell-selectable cell-focused'
      : 'cell-selectable'
  }

  const edges = cell.getSelectionEdges()

  return [
    'cell-selectable',
    'cell-selected',
    cell.getIsFocused() && 'cell-focused',
    edges.top && 'cell-edge-top',
    edges.right && 'cell-edge-right',
    edges.bottom && 'cell-edge-bottom',
    edges.left && 'cell-edge-left',
  ]
    .filter(Boolean)
    .join(' ')
}

const columns = columnHelper.columns([
  columnHelper.accessor('firstName', {
    header: 'First Name',
    cell: (info) => info.getValue(),
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor((row) => row.lastName, {
    id: 'lastName',
    header: () => 'Last Name',
    cell: (info) => info.getValue(),
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('age', {
    header: () => 'Age',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('visits', {
    header: () => 'Visits',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('status', {
    header: 'Status',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('progress', {
    header: 'Profile Progress',
    // enableCellSelection: false, // this column opts out of cell selection
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('email', {
    header: 'Email',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('phone', {
    header: 'Phone',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('city', {
    header: 'City',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('country', {
    header: 'Country',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('department', {
    header: 'Department',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('salary', {
    header: 'Salary',
    cell: (info) => info.getValue().toLocaleString(),
    footer: (props) => props.column.id,
  }),
])

function App() {
  const [data, setData] = createSignal(makeData(20))
  const refreshData = () => setData(makeData(20))
  const stressTest = () => setData(makeData(1_000))

  const table = createTable({
    key: 'cell-selection', // needed for devtools
    features,
    get data() {
      return data()
    },
    columns,
    getRowId: (row: Person) => row.id,
    enableCellSelection: true, // enable cell selection for all cells
    // initialState: { cellSelection: [] }, // select cells on first render
    // state: { cellSelection }, // classic controlled state; pair with onCellSelectionChange
    // onCellSelectionChange: setCellSelection,
    // enableCellRangeSelection: false, // disable Shift-click and drag ranges; default true
    // enableMultiCellRangeSelection: false, // allow only one rectangle at a time; default true
    // enableCellSelectionDrag: false, // disable drag-to-select; default true
    // isCellRangeSelectionEvent: event => Boolean(event.metaKey), // use Meta instead of Shift
    debugTable: true,
  })

  useTanStackTableDevtools(table)

  const randomizeColumns = () => {
    table.setColumnOrder(
      faker.helpers.shuffle(table.getAllLeafColumns().map((d) => d.id)),
    )
  }

  // optionally, reset the cellSelection state not only when data changes, but
  // also when column order, pinning, visibility, or sorting changes
  // customize this to your needs. `defer: true` skips the first run so an
  // initialState selection survives mount.
  createEffect(
    on(
      () => [
        table.atoms.columnOrder.get(),
        table.atoms.columnPinning.get(),
        table.atoms.columnVisibility.get(),
        table.atoms.sorting.get(),
      ],
      () => table.resetCellSelection(true),
      { defer: true },
    ),
  )

  let gridRef!: HTMLDivElement

  // keyboard navigation is TanStack Hotkeys driving the table's imperative
  // APIs; table-core ships no keydown handling of its own
  createHotkeys(
    [
      { hotkey: 'ArrowUp', callback: () => table.moveCellSelection('up') },
      { hotkey: 'ArrowDown', callback: () => table.moveCellSelection('down') },
      { hotkey: 'ArrowLeft', callback: () => table.moveCellSelection('left') },
      {
        hotkey: 'ArrowRight',
        callback: () => table.moveCellSelection('right'),
      },
      {
        hotkey: 'Shift+ArrowUp',
        callback: () => table.extendCellSelection('up'),
      },
      {
        hotkey: 'Shift+ArrowDown',
        callback: () => table.extendCellSelection('down'),
      },
      {
        hotkey: 'Shift+ArrowLeft',
        callback: () => table.extendCellSelection('left'),
      },
      {
        hotkey: 'Shift+ArrowRight',
        callback: () => table.extendCellSelection('right'),
      },
      { hotkey: 'Mod+A', callback: () => table.selectAllCells() },
      { hotkey: 'Escape', callback: () => table.resetCellSelection(true) },
      {
        hotkey: 'Mod+C',
        callback: () => {
          void navigator.clipboard.writeText(
            toTsv(table.getSelectedCellRangesData()),
          )
        },
      },
    ],
    () => ({ target: gridRef }),
  )

  return (
    <div class="demo-root">
      <div>
        <button
          class="demo-button demo-button-spaced"
          onClick={() => refreshData()}
        >
          Regenerate Data
        </button>
        <button
          class="demo-button demo-button-spaced"
          onClick={() => stressTest()}
        >
          Stress Test (1K rows)
        </button>
      </div>
      <div class="spacer-sm" />
      <p>
        Click and drag to select a range of cells. Hold Shift while clicking to
        extend the selection, or Ctrl/Cmd to add or subtract a rectangle. Arrow
        keys move the selection, Shift+Arrow extends it, Mod+A selects all,
        Mod+C copies, and Escape clears. Uncomment `enableCellSelection: false`
        on a column def to opt that column out of selection.
      </p>
      <p class="demo-note">
        Hiding, reordering, and pinning columns all keep a live selection
        anchored to the same cell ids. Ranges are indexed in render order, so a
        pinned column moves the rectangle with it rather than splitting it.
      </p>
      <div class="column-toggle-panel">
        <div class="column-toggle-panel-header">
          <label>
            <input
              type="checkbox"
              checked={table.getIsAllColumnsVisible()}
              onChange={table.getToggleAllColumnsVisibilityHandler()}
            />{' '}
            Toggle All
          </label>
        </div>
        <For each={table.getAllLeafColumns()}>
          {(column) => (
            <div class="column-toggle-row">
              <label>
                <input
                  type="checkbox"
                  checked={column.getIsVisible()}
                  onChange={column.getToggleVisibilityHandler()}
                />{' '}
                {column.id}
              </label>
            </div>
          )}
        </For>
      </div>
      <div class="spacer-sm" />
      <div class="button-row">
        <button
          class="demo-button demo-button-spaced"
          onClick={() => randomizeColumns()}
        >
          Shuffle Columns
        </button>
        <button
          class="demo-button demo-button-spaced"
          onClick={() =>
            table.setColumnOrder(
              [
                ...table.getAllLeafColumns().map((column) => column.id),
              ].reverse(),
            )
          }
        >
          Reverse Column Order
        </button>
        <button
          class="demo-button demo-button-spaced"
          onClick={() => table.resetColumnOrder()}
        >
          Reset Column Order
        </button>
        <button
          class="demo-button demo-button-spaced"
          onClick={() => table.resetColumnPinning()}
        >
          Reset Pinning
        </button>
        <button
          class="demo-button demo-button-spaced"
          onClick={() => table.resetColumnVisibility()}
        >
          Reset Visibility
        </button>
      </div>
      <div class="spacer-sm" />
      {/*
        Solid tracks atom reads natively, so this count re-evaluates on its own.
        There is no equivalent of React's per-row Subscribe to reach for here.
      */}
      <div>
        {table.getSelectedCellCount().toLocaleString()} cells selected across{' '}
        {table.getCellSelectionRowIds().length.toLocaleString()} rows and{' '}
        {table.getCellSelectionColumnIds().length} columns
      </div>
      <div class="spacer-sm" />
      <div ref={gridRef} tabindex={0}>
        <table>
          <thead>
            <For each={table.getHeaderGroups()}>
              {(headerGroup) => (
                <tr>
                  <For each={headerGroup.headers}>
                    {(header) => (
                      <th colSpan={header.colSpan}>
                        <Show when={!header.isPlaceholder}>
                          <button
                            type="button"
                            disabled={!header.column.getCanSort()}
                            class={
                              header.column.getCanSort()
                                ? 'header-button sortable-header'
                                : 'header-button'
                            }
                            onClick={header.column.getToggleSortingHandler()}
                          >
                            <FlexRender header={header} />
                            {{ asc: ' 🔼', desc: ' 🔽' }[
                              header.column.getIsSorted() as string
                            ] ?? null}
                          </button>
                          <Show when={header.column.getCanPin()}>
                            <div class="pin-actions">
                              <Show
                                when={header.column.getIsPinned() !== 'start'}
                              >
                                <button
                                  class="pin-button"
                                  onClick={() => header.column.pin('start')}
                                >
                                  {'<='}
                                </button>
                              </Show>
                              <Show when={header.column.getIsPinned()}>
                                <button
                                  class="pin-button"
                                  onClick={() => header.column.pin(false)}
                                >
                                  X
                                </button>
                              </Show>
                              <Show
                                when={header.column.getIsPinned() !== 'end'}
                              >
                                <button
                                  class="pin-button"
                                  onClick={() => header.column.pin('end')}
                                >
                                  {'=>'}
                                </button>
                              </Show>
                            </div>
                          </Show>
                        </Show>
                      </th>
                    )}
                  </For>
                </tr>
              )}
            </For>
          </thead>
          <tbody>
            <For each={table.getRowModel().rows}>
              {(row) => (
                <tr>
                  <For each={row.getVisibleCells()}>
                    {(cell) => (
                      <Show
                        when={cell.getCanSelect()}
                        fallback={
                          <td>
                            <FlexRender cell={cell} />
                          </td>
                        }
                      >
                        <td
                          class={getCellClassName(cell)}
                          tabindex={cell.getTabIndex()}
                          onMouseDown={cell.getSelectionStartHandler()}
                          onMouseEnter={cell.getSelectionExtendHandler()}
                        >
                          <FlexRender cell={cell} />
                        </td>
                      </Show>
                    )}
                  </For>
                </tr>
              )}
            </For>
          </tbody>
          <tfoot>
            <tr>
              <td colSpan={20}>
                Rows ({table.getRowModel().rows.length.toLocaleString()})
              </td>
            </tr>
          </tfoot>
        </table>
      </div>
      <div class="spacer-sm" />
      <div>
        <button
          class="demo-button demo-button-spaced"
          onClick={() =>
            void navigator.clipboard.writeText(
              toTsv(table.getSelectedCellRangesData()),
            )
          }
        >
          Copy Selection
        </button>
        <button
          class="demo-button demo-button-spaced"
          onClick={() => table.selectAllCells()}
        >
          Select All Cells
        </button>
        <button
          class="demo-button demo-button-spaced"
          onClick={() => table.resetCellSelection(true)}
        >
          Clear Selection
        </button>
      </div>
      <hr />
      <br />
      <div>
        <button
          class="demo-button demo-button-spaced"
          onClick={() =>
            console.info(
              'table.getSelectedCellRangesData()',
              table.getSelectedCellRangesData(),
            )
          }
        >
          Log table.getSelectedCellRangesData()
        </button>
      </div>
      <div>
        <label>State:</label>
        <pre>
          {data().length < 1_001
            ? JSON.stringify(table.store.get(), null, 2)
            : ''}
        </pre>
      </div>
      <div>
        <label for="paste-target">Paste Test:</label>
        {/*
          scratch area for pasting a copied selection back in, to eyeball the
          tab-separated shape. It sits outside the grid ref, so the table
          hotkeys never intercept typing or Mod+V in here.
        */}
        <textarea
          id="paste-target"
          class="text-input"
          rows={8}
          placeholder="Copy a selection, then paste here to check the tab-separated output..."
        />
      </div>
    </div>
  )
}

export default App

Svelte Example: Cell Selection

<script lang="ts">
  import { faker } from '@faker-js/faker'
  import { untrack } from 'svelte'
  import { createHotkeysAttachment } from '@tanstack/svelte-hotkeys'
  import {
    FlexRender,
    cellSelectionFeature,
    columnOrderingFeature,
    columnPinningFeature,
    columnVisibilityFeature,
    createColumnHelper,
    createSortedRowModel,
    createTable,
    rowSortingFeature,
    sortFn_alphanumeric,
    sortFn_datetime,
    sortFn_text,
    tableFeatures,
  } from '@tanstack/svelte-table'
  import { makeData } from './makeData'
  import type { Cell } from '@tanstack/svelte-table'
  import type { Person } from './makeData'
  import './index.css'

  const features = tableFeatures({
    cellSelectionFeature,
    columnOrderingFeature,
    columnPinningFeature,
    columnVisibilityFeature,
    rowSortingFeature,
    sortedRowModel: createSortedRowModel(),
    sortFns: {
      alphanumeric: sortFn_alphanumeric,
      datetime: sortFn_datetime,
      text: sortFn_text,
    },
  })

  const columnHelper = createColumnHelper<typeof features, Person>()

  // Serializing a selection for the clipboard is a userland concern: the table
  // hands back `getSelectedCellRangesData()` as raw values, and the delimiter,
  // the null representation, and the quoting rules are all yours to pick. This
  // is the spreadsheet-flavored version.
  function escapeTsvValue(value: unknown) {
    const text = value == null ? '' : String(value)
    const safeText =
      typeof value === 'string' && /^[\t\r ]*[=+@-]/.test(value)
        ? `'${text}`
        : text

    // spreadsheets expect a field to be quoted once it contains a delimiter, a
    // newline, or a quote, with inner quotes doubled
    return /["\t\n\r]/.test(safeText)
      ? `"${safeText.replace(/"/g, '""')}"`
      : safeText
  }

  function toTsv(ranges: Array<Array<Array<unknown>>>) {
    return ranges
      .map((grid) =>
        grid.map((row) => row.map(escapeTsvValue).join('\t')).join('\n'),
      )
      .join('\n\n') // blank line between final selected regions
  }

  function getCellClassName(cell: Cell<typeof features, Person>) {
    // Most cells in a large grid are unselected, so bail before asking for
    // edges. getSelectionEdges() would otherwise resolve the cell's position a
    // second time just to discover it is not selected.
    if (!cell.getIsSelected()) {
      return cell.getIsFocused()
        ? 'cell-selectable cell-focused'
        : 'cell-selectable'
    }

    const edges = cell.getSelectionEdges()

    return [
      'cell-selectable',
      'cell-selected',
      cell.getIsFocused() && 'cell-focused',
      edges.top && 'cell-edge-top',
      edges.right && 'cell-edge-right',
      edges.bottom && 'cell-edge-bottom',
      edges.left && 'cell-edge-left',
    ]
      .filter(Boolean)
      .join(' ')
  }

  const columns = columnHelper.columns([
    columnHelper.accessor('firstName', {
      header: 'First Name',
      cell: (info) => info.getValue(),
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor((row) => row.lastName, {
      id: 'lastName',
      header: () => 'Last Name',
      cell: (info) => info.getValue(),
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('age', {
      header: () => 'Age',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('visits', {
      header: () => 'Visits',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('status', {
      header: 'Status',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('progress', {
      header: 'Profile Progress',
      // enableCellSelection: false, // this column opts out of cell selection
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('email', {
      header: 'Email',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('phone', {
      header: 'Phone',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('city', {
      header: 'City',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('country', {
      header: 'Country',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('department', {
      header: 'Department',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('salary', {
      header: 'Salary',
      cell: (info) => info.getValue().toLocaleString(),
      footer: (props) => props.column.id,
    }),
  ])

  let data = $state(makeData(20))
  const refreshData = () => (data = makeData(20))
  const stressTest = () => (data = makeData(1_000))

  const table = createTable(
    {
      key: 'cell-selection',
      features,
      get data() {
        return data
      },
      columns,
      getRowId: (row: Person) => row.id,
      enableCellSelection: true, // enable cell selection for all cells
      // initialState: { cellSelection: [] }, // select cells on first render
      // state: { cellSelection }, // classic controlled state; pair with onCellSelectionChange
      // onCellSelectionChange: setCellSelection,
      // enableCellRangeSelection: false, // disable Shift-click and drag ranges; default true
      // enableMultiCellRangeSelection: false, // allow only one rectangle at a time; default true
      // enableCellSelectionDrag: false, // disable drag-to-select; default true
      // isCellRangeSelectionEvent: event => Boolean(event.metaKey), // use Meta instead of Shift
      debugTable: true,
    },
  )

  const randomizeColumns = () =>
    table.setColumnOrder(
      faker.helpers.shuffle(table.getAllLeafColumns().map((d) => d.id)),
    )

  const copySelection = () =>
    void navigator.clipboard.writeText(toTsv(table.getSelectedCellRangesData()))

  // optionally, reset the cellSelection state not only when data changes, but
  // also when column order, pinning, visibility, or sorting changes
  // customize this to your needs
  let isFirstColumnLayout = true
  $effect(() => {
    // Read only the layout atoms so selection changes do not re-run this
    // effect. A full `table.store.get()` read would track every state slice.
    void table.atoms.columnOrder.get()
    void table.atoms.columnPinning.get()
    void table.atoms.columnVisibility.get()
    void table.atoms.sorting.get()

    if (isFirstColumnLayout) {
      isFirstColumnLayout = false
      return
    }
    untrack(() => table.resetCellSelection(true))
  })

  // keyboard navigation is TanStack Hotkeys driving the table's imperative
  // APIs; table-core ships no keydown handling of its own
  const gridKeys = createHotkeysAttachment([
    { hotkey: 'ArrowUp', callback: () => table.moveCellSelection('up') },
    { hotkey: 'ArrowDown', callback: () => table.moveCellSelection('down') },
    { hotkey: 'ArrowLeft', callback: () => table.moveCellSelection('left') },
    { hotkey: 'ArrowRight', callback: () => table.moveCellSelection('right') },
    {
      hotkey: 'Shift+ArrowUp',
      callback: () => table.extendCellSelection('up'),
    },
    {
      hotkey: 'Shift+ArrowDown',
      callback: () => table.extendCellSelection('down'),
    },
    {
      hotkey: 'Shift+ArrowLeft',
      callback: () => table.extendCellSelection('left'),
    },
    {
      hotkey: 'Shift+ArrowRight',
      callback: () => table.extendCellSelection('right'),
    },
    { hotkey: 'Mod+A', callback: () => table.selectAllCells() },
    { hotkey: 'Escape', callback: () => table.resetCellSelection(true) },
    { hotkey: 'Mod+C', callback: () => copySelection() },
  ])
</script>

<div class="demo-root">
  <div>
    <button class="demo-button demo-button-spaced" onclick={() => refreshData()}
      >Regenerate Data</button
    >
    <button class="demo-button demo-button-spaced" onclick={() => stressTest()}
      >Stress Test (1K rows)</button
    >
  </div>
  <div class="spacer-sm"></div>
  <p>
    Click and drag to select a range of cells. Hold Shift while clicking to
    extend the selection, or Ctrl/Cmd to add or subtract a rectangle. Arrow keys move
    the selection, Shift+Arrow extends it, Mod+A selects all, Mod+C copies, and
    Escape clears. Uncomment `enableCellSelection: false` on a column def to opt
    that column out of selection.
  </p>
  <p class="demo-note">
    Hiding, reordering, and pinning columns all keep a live selection anchored
    to the same cell ids. Ranges are indexed in render order, so a pinned column
    moves the rectangle with it rather than splitting it.
  </p>
  <div class="column-toggle-panel">
    <div class="column-toggle-panel-header">
      <label>
        <input
          type="checkbox"
          checked={table.getIsAllColumnsVisible()}
          onchange={table.getToggleAllColumnsVisibilityHandler()}
        />
        Toggle All
      </label>
    </div>
    {#each table.getAllLeafColumns() as column (column.id)}
      <div class="column-toggle-row">
        <label>
          <input
            type="checkbox"
            checked={column.getIsVisible()}
            onchange={column.getToggleVisibilityHandler()}
          />
          {column.id}
        </label>
      </div>
    {/each}
  </div>
  <div class="spacer-sm"></div>
  <div class="button-row">
    <button
      class="demo-button demo-button-spaced"
      onclick={() => randomizeColumns()}>Shuffle Columns</button
    >
    <button
      class="demo-button demo-button-spaced"
      onclick={() =>
        table.setColumnOrder(
          [...table.getAllLeafColumns().map((column) => column.id)].reverse(),
        )}>Reverse Column Order</button
    >
    <button
      class="demo-button demo-button-spaced"
      onclick={() => table.resetColumnOrder()}>Reset Column Order</button
    >
    <button
      class="demo-button demo-button-spaced"
      onclick={() => table.resetColumnPinning()}>Reset Pinning</button
    >
    <button
      class="demo-button demo-button-spaced"
      onclick={() => table.resetColumnVisibility()}>Reset Visibility</button
    >
  </div>
  <div class="spacer-sm"></div>
  <!--
    Svelte's runes track this read, and the compiler updates only the affected
    text nodes. There is no equivalent of React's per-row Subscribe to reach for.
  -->
  <div>
    {table.getSelectedCellCount().toLocaleString()} cells selected across {table
      .getCellSelectionRowIds()
      .length.toLocaleString()} rows and {table.getCellSelectionColumnIds()
      .length} columns
  </div>
  <div class="spacer-sm"></div>
  <div>
    <table
      role="grid"
      aria-label="Cell selection grid"
      tabindex="0"
      {@attach gridKeys}
    >
      <thead>
        {#each table.getHeaderGroups() as headerGroup (headerGroup.id)}
          <tr>
            {#each headerGroup.headers as header (header.id)}
              <th colspan={header.colSpan}>
                {#if !header.isPlaceholder}
                  <button
                    type="button"
                    disabled={!header.column.getCanSort()}
                    class={header.column.getCanSort()
                      ? 'header-button sortable-header'
                      : 'header-button'}
                    onclick={header.column.getToggleSortingHandler()}
                  >
                    <FlexRender {header} />
                    {{ asc: ' 🔼', desc: ' 🔽' }[
                      header.column.getIsSorted() as string
                    ] ?? ''}
                  </button>
                  {#if header.column.getCanPin()}
                    <div class="pin-actions">
                      {#if header.column.getIsPinned() !== 'start'}
                        <button
                          class="pin-button"
                          onclick={() => header.column.pin('start')}
                          >{'<='}</button
                        >
                      {/if}
                      {#if header.column.getIsPinned()}
                        <button
                          class="pin-button"
                          onclick={() => header.column.pin(false)}>X</button
                        >
                      {/if}
                      {#if header.column.getIsPinned() !== 'end'}
                        <button
                          class="pin-button"
                          onclick={() => header.column.pin('end')}
                          >{'=>'}</button
                        >
                      {/if}
                    </div>
                  {/if}
                {/if}
              </th>
            {/each}
          </tr>
        {/each}
      </thead>
      <tbody>
        {#each table.getRowModel().rows as row (row.id)}
          <tr>
            {#each row.getVisibleCells() as cell (cell.id)}
              {#if cell.getCanSelect()}
                <td
                  class={getCellClassName(cell)}
                  tabindex={cell.getTabIndex()}
                  onmousedown={cell.getSelectionStartHandler()}
                  onmouseenter={cell.getSelectionExtendHandler()}
                >
                  <FlexRender {cell} />
                </td>
              {:else}
                <td>
                  <FlexRender {cell} />
                </td>
              {/if}
            {/each}
          </tr>
        {/each}
      </tbody>
      <tfoot>
        <tr>
          <td colspan={20}>
            Rows ({table.getRowModel().rows.length.toLocaleString()})
          </td>
        </tr>
      </tfoot>
    </table>
  </div>
  <div class="spacer-sm"></div>
  <div>
    <button
      class="demo-button demo-button-spaced"
      onclick={() => copySelection()}>Copy Selection</button
    >
    <button
      class="demo-button demo-button-spaced"
      onclick={() => table.selectAllCells()}>Select All Cells</button
    >
    <button
      class="demo-button demo-button-spaced"
      onclick={() => table.resetCellSelection(true)}>Clear Selection</button
    >
  </div>
  <hr />
  <br />
  <div>
    <button
      class="demo-button demo-button-spaced"
      onclick={() =>
        console.info(
          'table.getSelectedCellRangesData()',
          table.getSelectedCellRangesData(),
        )}>Log table.getSelectedCellRangesData()</button
    >
  </div>
  <div>
    <label for="state-dump">State:</label>
    <pre id="state-dump">{data.length < 1_001
        ? JSON.stringify(table.store.get(), null, 2)
        : ''}</pre>
  </div>
  <div>
    <label for="paste-target">Paste Test:</label>
    <!--
      scratch area for pasting a copied selection back in, to eyeball the
      tab-separated shape. It sits outside the grid element, so the table
      hotkeys never intercept typing or Mod+V in here.
    -->
    <textarea
      id="paste-target"
      class="text-input"
      rows={8}
      placeholder="Copy a selection, then paste here to check the tab-separated output..."
    ></textarea>
  </div>
</div>
<script lang="ts">
  import { faker } from '@faker-js/faker'
  import { untrack } from 'svelte'
  import { createHotkeysAttachment } from '@tanstack/svelte-hotkeys'
  import {
    FlexRender,
    cellSelectionFeature,
    columnOrderingFeature,
    columnPinningFeature,
    columnVisibilityFeature,
    createColumnHelper,
    createSortedRowModel,
    createTable,
    rowSortingFeature,
    sortFn_alphanumeric,
    sortFn_datetime,
    sortFn_text,
    tableFeatures,
  } from '@tanstack/svelte-table'
  import { makeData } from './makeData'
  import type { Cell } from '@tanstack/svelte-table'
  import type { Person } from './makeData'
  import './index.css'

  const features = tableFeatures({
    cellSelectionFeature,
    columnOrderingFeature,
    columnPinningFeature,
    columnVisibilityFeature,
    rowSortingFeature,
    sortedRowModel: createSortedRowModel(),
    sortFns: {
      alphanumeric: sortFn_alphanumeric,
      datetime: sortFn_datetime,
      text: sortFn_text,
    },
  })

  const columnHelper = createColumnHelper<typeof features, Person>()

  // Serializing a selection for the clipboard is a userland concern: the table
  // hands back `getSelectedCellRangesData()` as raw values, and the delimiter,
  // the null representation, and the quoting rules are all yours to pick. This
  // is the spreadsheet-flavored version.
  function escapeTsvValue(value: unknown) {
    const text = value == null ? '' : String(value)
    const safeText =
      typeof value === 'string' && /^[\t\r ]*[=+@-]/.test(value)
        ? `'${text}`
        : text

    // spreadsheets expect a field to be quoted once it contains a delimiter, a
    // newline, or a quote, with inner quotes doubled
    return /["\t\n\r]/.test(safeText)
      ? `"${safeText.replace(/"/g, '""')}"`
      : safeText
  }

  function toTsv(ranges: Array<Array<Array<unknown>>>) {
    return ranges
      .map((grid) =>
        grid.map((row) => row.map(escapeTsvValue).join('\t')).join('\n'),
      )
      .join('\n\n') // blank line between final selected regions
  }

  function getCellClassName(cell: Cell<typeof features, Person>) {
    // Most cells in a large grid are unselected, so bail before asking for
    // edges. getSelectionEdges() would otherwise resolve the cell's position a
    // second time just to discover it is not selected.
    if (!cell.getIsSelected()) {
      return cell.getIsFocused()
        ? 'cell-selectable cell-focused'
        : 'cell-selectable'
    }

    const edges = cell.getSelectionEdges()

    return [
      'cell-selectable',
      'cell-selected',
      cell.getIsFocused() && 'cell-focused',
      edges.top && 'cell-edge-top',
      edges.right && 'cell-edge-right',
      edges.bottom && 'cell-edge-bottom',
      edges.left && 'cell-edge-left',
    ]
      .filter(Boolean)
      .join(' ')
  }

  const columns = columnHelper.columns([
    columnHelper.accessor('firstName', {
      header: 'First Name',
      cell: (info) => info.getValue(),
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor((row) => row.lastName, {
      id: 'lastName',
      header: () => 'Last Name',
      cell: (info) => info.getValue(),
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('age', {
      header: () => 'Age',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('visits', {
      header: () => 'Visits',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('status', {
      header: 'Status',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('progress', {
      header: 'Profile Progress',
      // enableCellSelection: false, // this column opts out of cell selection
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('email', {
      header: 'Email',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('phone', {
      header: 'Phone',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('city', {
      header: 'City',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('country', {
      header: 'Country',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('department', {
      header: 'Department',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('salary', {
      header: 'Salary',
      cell: (info) => info.getValue().toLocaleString(),
      footer: (props) => props.column.id,
    }),
  ])

  let data = $state(makeData(20))
  const refreshData = () => (data = makeData(20))
  const stressTest = () => (data = makeData(1_000))

  const table = createTable(
    {
      key: 'cell-selection',
      features,
      get data() {
        return data
      },
      columns,
      getRowId: (row: Person) => row.id,
      enableCellSelection: true, // enable cell selection for all cells
      // initialState: { cellSelection: [] }, // select cells on first render
      // state: { cellSelection }, // classic controlled state; pair with onCellSelectionChange
      // onCellSelectionChange: setCellSelection,
      // enableCellRangeSelection: false, // disable Shift-click and drag ranges; default true
      // enableMultiCellRangeSelection: false, // allow only one rectangle at a time; default true
      // enableCellSelectionDrag: false, // disable drag-to-select; default true
      // isCellRangeSelectionEvent: event => Boolean(event.metaKey), // use Meta instead of Shift
      debugTable: true,
    },
  )

  const randomizeColumns = () =>
    table.setColumnOrder(
      faker.helpers.shuffle(table.getAllLeafColumns().map((d) => d.id)),
    )

  const copySelection = () =>
    void navigator.clipboard.writeText(toTsv(table.getSelectedCellRangesData()))

  // optionally, reset the cellSelection state not only when data changes, but
  // also when column order, pinning, visibility, or sorting changes
  // customize this to your needs
  let isFirstColumnLayout = true
  $effect(() => {
    // Read only the layout atoms so selection changes do not re-run this
    // effect. A full `table.store.get()` read would track every state slice.
    void table.atoms.columnOrder.get()
    void table.atoms.columnPinning.get()
    void table.atoms.columnVisibility.get()
    void table.atoms.sorting.get()

    if (isFirstColumnLayout) {
      isFirstColumnLayout = false
      return
    }
    untrack(() => table.resetCellSelection(true))
  })

  // keyboard navigation is TanStack Hotkeys driving the table's imperative
  // APIs; table-core ships no keydown handling of its own
  const gridKeys = createHotkeysAttachment([
    { hotkey: 'ArrowUp', callback: () => table.moveCellSelection('up') },
    { hotkey: 'ArrowDown', callback: () => table.moveCellSelection('down') },
    { hotkey: 'ArrowLeft', callback: () => table.moveCellSelection('left') },
    { hotkey: 'ArrowRight', callback: () => table.moveCellSelection('right') },
    {
      hotkey: 'Shift+ArrowUp',
      callback: () => table.extendCellSelection('up'),
    },
    {
      hotkey: 'Shift+ArrowDown',
      callback: () => table.extendCellSelection('down'),
    },
    {
      hotkey: 'Shift+ArrowLeft',
      callback: () => table.extendCellSelection('left'),
    },
    {
      hotkey: 'Shift+ArrowRight',
      callback: () => table.extendCellSelection('right'),
    },
    { hotkey: 'Mod+A', callback: () => table.selectAllCells() },
    { hotkey: 'Escape', callback: () => table.resetCellSelection(true) },
    { hotkey: 'Mod+C', callback: () => copySelection() },
  ])
</script>

<div class="demo-root">
  <div>
    <button class="demo-button demo-button-spaced" onclick={() => refreshData()}
      >Regenerate Data</button
    >
    <button class="demo-button demo-button-spaced" onclick={() => stressTest()}
      >Stress Test (1K rows)</button
    >
  </div>
  <div class="spacer-sm"></div>
  <p>
    Click and drag to select a range of cells. Hold Shift while clicking to
    extend the selection, or Ctrl/Cmd to add or subtract a rectangle. Arrow keys move
    the selection, Shift+Arrow extends it, Mod+A selects all, Mod+C copies, and
    Escape clears. Uncomment `enableCellSelection: false` on a column def to opt
    that column out of selection.
  </p>
  <p class="demo-note">
    Hiding, reordering, and pinning columns all keep a live selection anchored
    to the same cell ids. Ranges are indexed in render order, so a pinned column
    moves the rectangle with it rather than splitting it.
  </p>
  <div class="column-toggle-panel">
    <div class="column-toggle-panel-header">
      <label>
        <input
          type="checkbox"
          checked={table.getIsAllColumnsVisible()}
          onchange={table.getToggleAllColumnsVisibilityHandler()}
        />
        Toggle All
      </label>
    </div>
    {#each table.getAllLeafColumns() as column (column.id)}
      <div class="column-toggle-row">
        <label>
          <input
            type="checkbox"
            checked={column.getIsVisible()}
            onchange={column.getToggleVisibilityHandler()}
          />
          {column.id}
        </label>
      </div>
    {/each}
  </div>
  <div class="spacer-sm"></div>
  <div class="button-row">
    <button
      class="demo-button demo-button-spaced"
      onclick={() => randomizeColumns()}>Shuffle Columns</button
    >
    <button
      class="demo-button demo-button-spaced"
      onclick={() =>
        table.setColumnOrder(
          [...table.getAllLeafColumns().map((column) => column.id)].reverse(),
        )}>Reverse Column Order</button
    >
    <button
      class="demo-button demo-button-spaced"
      onclick={() => table.resetColumnOrder()}>Reset Column Order</button
    >
    <button
      class="demo-button demo-button-spaced"
      onclick={() => table.resetColumnPinning()}>Reset Pinning</button
    >
    <button
      class="demo-button demo-button-spaced"
      onclick={() => table.resetColumnVisibility()}>Reset Visibility</button
    >
  </div>
  <div class="spacer-sm"></div>
  <!--
    Svelte's runes track this read, and the compiler updates only the affected
    text nodes. There is no equivalent of React's per-row Subscribe to reach for.
  -->
  <div>
    {table.getSelectedCellCount().toLocaleString()} cells selected across {table
      .getCellSelectionRowIds()
      .length.toLocaleString()} rows and {table.getCellSelectionColumnIds()
      .length} columns
  </div>
  <div class="spacer-sm"></div>
  <div>
    <table
      role="grid"
      aria-label="Cell selection grid"
      tabindex="0"
      {@attach gridKeys}
    >
      <thead>
        {#each table.getHeaderGroups() as headerGroup (headerGroup.id)}
          <tr>
            {#each headerGroup.headers as header (header.id)}
              <th colspan={header.colSpan}>
                {#if !header.isPlaceholder}
                  <button
                    type="button"
                    disabled={!header.column.getCanSort()}
                    class={header.column.getCanSort()
                      ? 'header-button sortable-header'
                      : 'header-button'}
                    onclick={header.column.getToggleSortingHandler()}
                  >
                    <FlexRender {header} />
                    {{ asc: ' 🔼', desc: ' 🔽' }[
                      header.column.getIsSorted() as string
                    ] ?? ''}
                  </button>
                  {#if header.column.getCanPin()}
                    <div class="pin-actions">
                      {#if header.column.getIsPinned() !== 'start'}
                        <button
                          class="pin-button"
                          onclick={() => header.column.pin('start')}
                          >{'<='}</button
                        >
                      {/if}
                      {#if header.column.getIsPinned()}
                        <button
                          class="pin-button"
                          onclick={() => header.column.pin(false)}>X</button
                        >
                      {/if}
                      {#if header.column.getIsPinned() !== 'end'}
                        <button
                          class="pin-button"
                          onclick={() => header.column.pin('end')}
                          >{'=>'}</button
                        >
                      {/if}
                    </div>
                  {/if}
                {/if}
              </th>
            {/each}
          </tr>
        {/each}
      </thead>
      <tbody>
        {#each table.getRowModel().rows as row (row.id)}
          <tr>
            {#each row.getVisibleCells() as cell (cell.id)}
              {#if cell.getCanSelect()}
                <td
                  class={getCellClassName(cell)}
                  tabindex={cell.getTabIndex()}
                  onmousedown={cell.getSelectionStartHandler()}
                  onmouseenter={cell.getSelectionExtendHandler()}
                >
                  <FlexRender {cell} />
                </td>
              {:else}
                <td>
                  <FlexRender {cell} />
                </td>
              {/if}
            {/each}
          </tr>
        {/each}
      </tbody>
      <tfoot>
        <tr>
          <td colspan={20}>
            Rows ({table.getRowModel().rows.length.toLocaleString()})
          </td>
        </tr>
      </tfoot>
    </table>
  </div>
  <div class="spacer-sm"></div>
  <div>
    <button
      class="demo-button demo-button-spaced"
      onclick={() => copySelection()}>Copy Selection</button
    >
    <button
      class="demo-button demo-button-spaced"
      onclick={() => table.selectAllCells()}>Select All Cells</button
    >
    <button
      class="demo-button demo-button-spaced"
      onclick={() => table.resetCellSelection(true)}>Clear Selection</button
    >
  </div>
  <hr />
  <br />
  <div>
    <button
      class="demo-button demo-button-spaced"
      onclick={() =>
        console.info(
          'table.getSelectedCellRangesData()',
          table.getSelectedCellRangesData(),
        )}>Log table.getSelectedCellRangesData()</button
    >
  </div>
  <div>
    <label for="state-dump">State:</label>
    <pre id="state-dump">{data.length < 1_001
        ? JSON.stringify(table.store.get(), null, 2)
        : ''}</pre>
  </div>
  <div>
    <label for="paste-target">Paste Test:</label>
    <!--
      scratch area for pasting a copied selection back in, to eyeball the
      tab-separated shape. It sits outside the grid element, so the table
      hotkeys never intercept typing or Mod+V in here.
    -->
    <textarea
      id="paste-target"
      class="text-input"
      rows={8}
      placeholder="Copy a selection, then paste here to check the tab-separated output..."
    ></textarea>
  </div>
</div>

React Example: Cell Selection

import React from 'react'
import { faker } from '@faker-js/faker'
import { TanStackDevtools } from '@tanstack/react-devtools'
import ReactDOM from 'react-dom/client'
import {
  cellSelectionFeature,
  columnOrderingFeature,
  columnPinningFeature,
  columnVisibilityFeature,
  createColumnHelper,
  createSortedRowModel,
  rowSortingFeature,
  sortFn_alphanumeric,
  sortFn_datetime,
  sortFn_text,
  tableFeatures,
  useTable,
} from '@tanstack/react-table'
import {
  tableDevtoolsPlugin,
  useTanStackTableDevtools,
} from '@tanstack/react-table-devtools'
import { useHotkeys } from '@tanstack/react-hotkeys'
import { useCreateAtom } from '@tanstack/react-store'
import { makeData } from './makeData'
import type { Person } from './makeData'
import type {
  Cell,
  CellSelectionBounds,
  CellSelectionState,
} from '@tanstack/react-table'
import './index.css'

const features = tableFeatures({
  cellSelectionFeature,
  columnOrderingFeature,
  columnPinningFeature,
  columnVisibilityFeature,
  rowSortingFeature,
  sortedRowModel: createSortedRowModel(),
  sortFns: {
    alphanumeric: sortFn_alphanumeric,
    datetime: sortFn_datetime,
    text: sortFn_text,
  },
})

const columnHelper = createColumnHelper<typeof features, Person>()

// Serializing a selection for the clipboard is a userland concern: the table
// hands back `getSelectedCellRangesData()` as raw values, and the delimiter,
// the null representation, and the quoting rules are all yours to pick. This is
// the spreadsheet-flavored version.
function escapeTsvValue(value: unknown) {
  const text = value == null ? '' : String(value)
  const safeText =
    typeof value === 'string' && /^[\t\r ]*[=+@-]/.test(value)
      ? `'${text}`
      : text

  // spreadsheets expect a field to be quoted once it contains a delimiter, a
  // newline, or a quote, with inner quotes doubled
  return /["\t\n\r]/.test(safeText)
    ? `"${safeText.replace(/"/g, '""')}"`
    : safeText
}

function toTsv(ranges: Array<Array<Array<unknown>>>) {
  return ranges
    .map((grid) =>
      grid.map((row) => row.map(escapeTsvValue).join('\t')).join('\n'),
    )
    .join('\n\n') // blank line between final selected regions
}

function App() {
  const columns = React.useMemo(
    () =>
      columnHelper.columns([
        columnHelper.accessor('firstName', {
          header: 'First Name',
          cell: (info) => info.getValue(),
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor((row) => row.lastName, {
          id: 'lastName',
          header: () => <span>Last Name</span>,
          cell: (info) => info.getValue(),
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('age', {
          header: () => 'Age',
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('visits', {
          header: () => <span>Visits</span>,
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('status', {
          header: 'Status',
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('progress', {
          header: 'Profile Progress',
          // enableCellSelection: false, // this column opts out of cell selection
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('email', {
          header: 'Email',
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('phone', {
          header: 'Phone',
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('city', {
          header: 'City',
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('country', {
          header: 'Country',
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('department', {
          header: 'Department',
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('salary', {
          header: 'Salary',
          cell: (info) => info.getValue().toLocaleString(),
          footer: (props) => props.column.id,
        }),
      ]),
    [],
  )

  const [data, setData] = React.useState(() => makeData(20))
  const refreshData = () => setData(makeData(20))
  const stressTest = () => setData(makeData(1_000))

  // optionally, raise the selection state to your own atom
  const cellSelectionAtom = useCreateAtom<CellSelectionState>([])

  const table = useTable(
    {
      key: 'cell-selection', // needed for devtools
      features,
      atoms: {
        cellSelection: cellSelectionAtom,
      },
      columns,
      data,
      getRowId: (row) => row.id,
      enableCellSelection: true, // enable cell selection for all cells
      // initialState: { cellSelection: [] }, // select cells on first render
      // state: { cellSelection }, // classic controlled state; pair with onCellSelectionChange
      // onCellSelectionChange: setCellSelection,
      // enableCellRangeSelection: false, // disable Shift-click and drag ranges; default true
      // enableMultiCellRangeSelection: false, // allow only one rectangle at a time; default true
      // enableCellSelectionDrag: false, // disable drag-to-select; default true
      // isCellRangeSelectionEvent: event => Boolean(event.metaKey), // use Meta instead of Shift
      debugTable: true,
    },
    // Every slice that changes the table's structure has to be here, or the
    // headers and controls will not re-render when you pin, hide, or reorder.
    // cellSelection is the deliberate exception: it is read through <Subscribe>
    // instead, so a drag does not re-render the whole example.
    (state) => ({
      sorting: state.sorting,
      columnVisibility: state.columnVisibility,
      columnOrder: state.columnOrder,
      columnPinning: state.columnPinning,
    }),
  )

  useTanStackTableDevtools(table)

  const randomizeColumns = () => {
    table.setColumnOrder(
      faker.helpers.shuffle(table.getAllLeafColumns().map((d) => d.id)),
    )
  }

  // optionally, reset the cellSelection state not only when data changes, but also when column order, pinning, visibility, or sorting changes
  // customize this to your needs
  const isFirstColumnLayout = React.useRef(true)
  React.useEffect(() => {
    if (isFirstColumnLayout.current) {
      isFirstColumnLayout.current = false
      return
    }
    table.resetCellSelection(true)
  }, [
    table.state.columnOrder,
    table.state.columnPinning,
    table.state.columnVisibility,
    table.state.sorting,
  ])

  const gridRef = React.useRef<HTMLDivElement>(null)

  // keyboard navigation is TanStack Hotkeys driving the table's imperative APIs;
  // table-core ships no keydown handling of its own
  useHotkeys(
    [
      { hotkey: 'ArrowUp', callback: () => table.moveCellSelection('up') },
      { hotkey: 'ArrowDown', callback: () => table.moveCellSelection('down') },
      { hotkey: 'ArrowLeft', callback: () => table.moveCellSelection('left') },
      {
        hotkey: 'ArrowRight',
        callback: () => table.moveCellSelection('right'),
      },
      {
        hotkey: 'Shift+ArrowUp',
        callback: () => table.extendCellSelection('up'),
      },
      {
        hotkey: 'Shift+ArrowDown',
        callback: () => table.extendCellSelection('down'),
      },
      {
        hotkey: 'Shift+ArrowLeft',
        callback: () => table.extendCellSelection('left'),
      },
      {
        hotkey: 'Shift+ArrowRight',
        callback: () => table.extendCellSelection('right'),
      },
      { hotkey: 'Mod+A', callback: () => table.selectAllCells() },
      { hotkey: 'Escape', callback: () => table.resetCellSelection(true) },
      {
        hotkey: 'Mod+C',
        callback: () => {
          void navigator.clipboard.writeText(
            toTsv(table.getSelectedCellRangesData()),
          )
        },
      },
    ],
    { target: gridRef },
  )

  return (
    <div className="demo-root">
      <div>
        <button
          className="demo-button demo-button-spaced"
          onClick={() => refreshData()}
        >
          Regenerate Data
        </button>
        <button
          className="demo-button demo-button-spaced"
          onClick={() => stressTest()}
        >
          Stress Test (1K rows)
        </button>
      </div>
      <div className="spacer-sm" />
      <p>
        Click and drag to select a range of cells. Hold Shift while clicking to
        extend the selection, or Ctrl/Cmd to add or subtract a rectangle. Arrow
        keys move the selection, Shift+Arrow extends it, Mod+A selects all,
        Mod+C copies, and Escape clears. Uncomment `enableCellSelection: false`
        on a column def to opt that column out of selection.
      </p>
      <p className="demo-note">
        Hiding, reordering, and pinning columns all keep a live selection
        anchored to the same cell ids. Ranges are indexed in render order, so a
        pinned column moves the rectangle with it rather than splitting it.
      </p>
      <div className="column-toggle-panel">
        <div className="column-toggle-panel-header">
          <label>
            <input
              type="checkbox"
              checked={table.getIsAllColumnsVisible()}
              onChange={table.getToggleAllColumnsVisibilityHandler()}
            />{' '}
            Toggle All
          </label>
        </div>
        {table.getAllLeafColumns().map((column) => (
          <div key={column.id} className="column-toggle-row">
            <label>
              <input
                type="checkbox"
                checked={column.getIsVisible()}
                onChange={column.getToggleVisibilityHandler()}
              />{' '}
              {column.id}
            </label>
          </div>
        ))}
      </div>
      <div className="spacer-sm" />
      <div className="button-row">
        <button
          className="demo-button demo-button-spaced"
          onClick={() => randomizeColumns()}
        >
          Shuffle Columns
        </button>
        <button
          className="demo-button demo-button-spaced"
          onClick={() =>
            table.setColumnOrder(
              [
                ...table.getAllLeafColumns().map((column) => column.id),
              ].reverse(),
            )
          }
        >
          Reverse Column Order
        </button>
        <button
          className="demo-button demo-button-spaced"
          onClick={() => table.resetColumnOrder()}
        >
          Reset Column Order
        </button>
        <button
          className="demo-button demo-button-spaced"
          onClick={() => table.resetColumnPinning()}
        >
          Reset Pinning
        </button>
        <button
          className="demo-button demo-button-spaced"
          onClick={() => table.resetColumnVisibility()}
        >
          Reset Visibility
        </button>
      </div>
      <div className="spacer-sm" />
      <table.Subscribe source={table.atoms.cellSelection}>
        {() => (
          <div>
            {table.getSelectedCellCount().toLocaleString()} cells selected
            across {table.getCellSelectionRowIds().length.toLocaleString()} rows
            and {table.getCellSelectionColumnIds().length} columns
          </div>
        )}
      </table.Subscribe>
      <div className="spacer-sm" />
      <div ref={gridRef} tabIndex={0}>
        <table>
          <thead>
            {table.getHeaderGroups().map((headerGroup) => (
              <tr key={headerGroup.id}>
                {headerGroup.headers.map((header) => {
                  return (
                    <th key={header.id} colSpan={header.colSpan}>
                      {header.isPlaceholder ? null : (
                        <>
                          <button
                            type="button"
                            disabled={!header.column.getCanSort()}
                            className={
                              header.column.getCanSort()
                                ? 'header-button sortable-header'
                                : 'header-button'
                            }
                            onClick={header.column.getToggleSortingHandler()}
                          >
                            <table.FlexRender header={header} />
                            {{ asc: ' 🔼', desc: ' 🔽' }[
                              header.column.getIsSorted() as string
                            ] ?? null}
                          </button>
                          {header.column.getCanPin() && (
                            <div className="pin-actions">
                              {header.column.getIsPinned() !== 'start' ? (
                                <button
                                  className="pin-button"
                                  onClick={() => header.column.pin('start')}
                                >
                                  {'<='}
                                </button>
                              ) : null}
                              {header.column.getIsPinned() ? (
                                <button
                                  className="pin-button"
                                  onClick={() => header.column.pin(false)}
                                >
                                  X
                                </button>
                              ) : null}
                              {header.column.getIsPinned() !== 'end' ? (
                                <button
                                  className="pin-button"
                                  onClick={() => header.column.pin('end')}
                                >
                                  {'=>'}
                                </button>
                              ) : null}
                            </div>
                          )}
                        </>
                      )}
                    </th>
                  )
                })}
              </tr>
            ))}
          </thead>
          <tbody>
            {table.getRowModel().rows.map((row) => (
              // one subscription per row rather than one around the whole
              // tbody, so a drag only re-renders the rows whose key changed
              <table.Subscribe
                key={row.id}
                source={table.atoms.cellSelection}
                selector={(ranges) =>
                  rowSelectionKey(
                    ranges,
                    table.getCellSelectionBounds(),
                    row.getDisplayIndex(),
                    row.id,
                  )
                }
              >
                {() => (
                  <tr>
                    {row.getVisibleCells().map((cell) =>
                      cell.getCanSelect() ? (
                        <td
                          key={cell.id}
                          className={getCellClassName(cell)}
                          tabIndex={cell.getTabIndex()}
                          onMouseDown={cell.getSelectionStartHandler()}
                          onMouseEnter={cell.getSelectionExtendHandler()}
                        >
                          <table.FlexRender cell={cell} />
                        </td>
                      ) : (
                        <td key={cell.id}>
                          <table.FlexRender cell={cell} />
                        </td>
                      ),
                    )}
                  </tr>
                )}
              </table.Subscribe>
            ))}
          </tbody>
          <tfoot>
            <tr>
              <td colSpan={20}>
                Rows ({table.getRowModel().rows.length.toLocaleString()})
              </td>
            </tr>
          </tfoot>
        </table>
      </div>
      <div className="spacer-sm" />
      <div>
        <button
          className="demo-button demo-button-spaced"
          onClick={() =>
            void navigator.clipboard.writeText(
              toTsv(table.getSelectedCellRangesData()),
            )
          }
        >
          Copy Selection
        </button>
        <button
          className="demo-button demo-button-spaced"
          onClick={() => table.selectAllCells()}
        >
          Select All Cells
        </button>
        <button
          className="demo-button demo-button-spaced"
          onClick={() => table.resetCellSelection(true)}
        >
          Clear Selection
        </button>
      </div>
      <hr />
      <br />
      <div>
        <button
          className="demo-button demo-button-spaced"
          onClick={() =>
            console.info(
              'table.getSelectedCellRangesData()',
              table.getSelectedCellRangesData(),
            )
          }
        >
          Log table.getSelectedCellRangesData()
        </button>
      </div>
      <div>
        <label>State:</label>
        <table.Subscribe selector={(state) => state}>
          {(state) => (
            <pre>{data.length < 1_001 && JSON.stringify(state, null, 2)}</pre>
          )}
        </table.Subscribe>
      </div>
      <div>
        <label htmlFor="paste-target">Paste Test:</label>
        {/* scratch area for pasting a copied selection back in, to eyeball
              the tab-separated shape. It sits outside the grid ref, so the
              table hotkeys never intercept typing or Mod+V in here. */}
        <textarea
          id="paste-target"
          className="text-input"
          rows={8}
          placeholder="Copy a selection, then paste here to check the tab-separated output..."
        />
      </div>
    </div>
  )
}

// each cell draws only the sides getSelectionEdges() reports as the boundary of
// the selection, so a union of rectangles gets one continuous outline
/**
 * The narrowest value a row's appearance depends on: whether its own cells fall
 * inside a range, whether the rows immediately above and below do (that decides
 * its top and bottom edges), and whether it owns the focused cell.
 *
 * Rows in the middle of a growing range produce an unchanged key, so <Subscribe>
 * skips re-rendering them. Column layout is deliberately absent: those changes
 * re-render App, which recreates these rows anyway.
 */
function rowSelectionKey(
  ranges: CellSelectionState,
  bounds: Array<CellSelectionBounds>,
  rowIndex: number,
  rowId: string,
) {
  const active = ranges[ranges.length - 1]
  let key =
    ranges.length > 0 && active.anchorRowId === rowId
      ? `f${active.anchorColumnId}`
      : ''

  for (const bound of bounds) {
    const self = rowIndex >= bound.minRowIndex && rowIndex <= bound.maxRowIndex
    const above =
      rowIndex - 1 >= bound.minRowIndex && rowIndex - 1 <= bound.maxRowIndex
    const below =
      rowIndex + 1 >= bound.minRowIndex && rowIndex + 1 <= bound.maxRowIndex

    if (self || above || below) {
      key += `|${self ? 1 : 0}${above ? 1 : 0}${below ? 1 : 0}:${bound.minColumnIndex}-${bound.maxColumnIndex}`
    }
  }

  return key
}

function getCellClassName(cell: Cell<typeof features, Person>) {
  // Most cells in a large grid are unselected, so bail before asking for edges.
  // getSelectionEdges() would otherwise resolve the cell's position a second
  // time just to discover it is not selected.
  if (!cell.getIsSelected()) {
    return cell.getIsFocused()
      ? 'cell-selectable cell-focused'
      : 'cell-selectable'
  }

  const edges = cell.getSelectionEdges()

  return [
    'cell-selectable',
    'cell-selected',
    cell.getIsFocused() && 'cell-focused',
    edges.top && 'cell-edge-top',
    edges.right && 'cell-edge-right',
    edges.bottom && 'cell-edge-bottom',
    edges.left && 'cell-edge-left',
  ]
    .filter(Boolean)
    .join(' ')
}

const rootElement = document.getElementById('root')
if (!rootElement) throw new Error('Failed to find the root element')

ReactDOM.createRoot(rootElement).render(
  <React.StrictMode>
    <App />
    <TanStackDevtools plugins={[tableDevtoolsPlugin()]} />
  </React.StrictMode>,
)
import React from 'react'
import { faker } from '@faker-js/faker'
import { TanStackDevtools } from '@tanstack/react-devtools'
import ReactDOM from 'react-dom/client'
import {
  cellSelectionFeature,
  columnOrderingFeature,
  columnPinningFeature,
  columnVisibilityFeature,
  createColumnHelper,
  createSortedRowModel,
  rowSortingFeature,
  sortFn_alphanumeric,
  sortFn_datetime,
  sortFn_text,
  tableFeatures,
  useTable,
} from '@tanstack/react-table'
import {
  tableDevtoolsPlugin,
  useTanStackTableDevtools,
} from '@tanstack/react-table-devtools'
import { useHotkeys } from '@tanstack/react-hotkeys'
import { useCreateAtom } from '@tanstack/react-store'
import { makeData } from './makeData'
import type { Person } from './makeData'
import type {
  Cell,
  CellSelectionBounds,
  CellSelectionState,
} from '@tanstack/react-table'
import './index.css'

const features = tableFeatures({
  cellSelectionFeature,
  columnOrderingFeature,
  columnPinningFeature,
  columnVisibilityFeature,
  rowSortingFeature,
  sortedRowModel: createSortedRowModel(),
  sortFns: {
    alphanumeric: sortFn_alphanumeric,
    datetime: sortFn_datetime,
    text: sortFn_text,
  },
})

const columnHelper = createColumnHelper<typeof features, Person>()

// Serializing a selection for the clipboard is a userland concern: the table
// hands back `getSelectedCellRangesData()` as raw values, and the delimiter,
// the null representation, and the quoting rules are all yours to pick. This is
// the spreadsheet-flavored version.
function escapeTsvValue(value: unknown) {
  const text = value == null ? '' : String(value)
  const safeText =
    typeof value === 'string' && /^[\t\r ]*[=+@-]/.test(value)
      ? `'${text}`
      : text

  // spreadsheets expect a field to be quoted once it contains a delimiter, a
  // newline, or a quote, with inner quotes doubled
  return /["\t\n\r]/.test(safeText)
    ? `"${safeText.replace(/"/g, '""')}"`
    : safeText
}

function toTsv(ranges: Array<Array<Array<unknown>>>) {
  return ranges
    .map((grid) =>
      grid.map((row) => row.map(escapeTsvValue).join('\t')).join('\n'),
    )
    .join('\n\n') // blank line between final selected regions
}

function App() {
  const columns = React.useMemo(
    () =>
      columnHelper.columns([
        columnHelper.accessor('firstName', {
          header: 'First Name',
          cell: (info) => info.getValue(),
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor((row) => row.lastName, {
          id: 'lastName',
          header: () => <span>Last Name</span>,
          cell: (info) => info.getValue(),
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('age', {
          header: () => 'Age',
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('visits', {
          header: () => <span>Visits</span>,
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('status', {
          header: 'Status',
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('progress', {
          header: 'Profile Progress',
          // enableCellSelection: false, // this column opts out of cell selection
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('email', {
          header: 'Email',
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('phone', {
          header: 'Phone',
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('city', {
          header: 'City',
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('country', {
          header: 'Country',
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('department', {
          header: 'Department',
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('salary', {
          header: 'Salary',
          cell: (info) => info.getValue().toLocaleString(),
          footer: (props) => props.column.id,
        }),
      ]),
    [],
  )

  const [data, setData] = React.useState(() => makeData(20))
  const refreshData = () => setData(makeData(20))
  const stressTest = () => setData(makeData(1_000))

  // optionally, raise the selection state to your own atom
  const cellSelectionAtom = useCreateAtom<CellSelectionState>([])

  const table = useTable(
    {
      key: 'cell-selection', // needed for devtools
      features,
      atoms: {
        cellSelection: cellSelectionAtom,
      },
      columns,
      data,
      getRowId: (row) => row.id,
      enableCellSelection: true, // enable cell selection for all cells
      // initialState: { cellSelection: [] }, // select cells on first render
      // state: { cellSelection }, // classic controlled state; pair with onCellSelectionChange
      // onCellSelectionChange: setCellSelection,
      // enableCellRangeSelection: false, // disable Shift-click and drag ranges; default true
      // enableMultiCellRangeSelection: false, // allow only one rectangle at a time; default true
      // enableCellSelectionDrag: false, // disable drag-to-select; default true
      // isCellRangeSelectionEvent: event => Boolean(event.metaKey), // use Meta instead of Shift
      debugTable: true,
    },
    // Every slice that changes the table's structure has to be here, or the
    // headers and controls will not re-render when you pin, hide, or reorder.
    // cellSelection is the deliberate exception: it is read through <Subscribe>
    // instead, so a drag does not re-render the whole example.
    (state) => ({
      sorting: state.sorting,
      columnVisibility: state.columnVisibility,
      columnOrder: state.columnOrder,
      columnPinning: state.columnPinning,
    }),
  )

  useTanStackTableDevtools(table)

  const randomizeColumns = () => {
    table.setColumnOrder(
      faker.helpers.shuffle(table.getAllLeafColumns().map((d) => d.id)),
    )
  }

  // optionally, reset the cellSelection state not only when data changes, but also when column order, pinning, visibility, or sorting changes
  // customize this to your needs
  const isFirstColumnLayout = React.useRef(true)
  React.useEffect(() => {
    if (isFirstColumnLayout.current) {
      isFirstColumnLayout.current = false
      return
    }
    table.resetCellSelection(true)
  }, [
    table.state.columnOrder,
    table.state.columnPinning,
    table.state.columnVisibility,
    table.state.sorting,
  ])

  const gridRef = React.useRef<HTMLDivElement>(null)

  // keyboard navigation is TanStack Hotkeys driving the table's imperative APIs;
  // table-core ships no keydown handling of its own
  useHotkeys(
    [
      { hotkey: 'ArrowUp', callback: () => table.moveCellSelection('up') },
      { hotkey: 'ArrowDown', callback: () => table.moveCellSelection('down') },
      { hotkey: 'ArrowLeft', callback: () => table.moveCellSelection('left') },
      {
        hotkey: 'ArrowRight',
        callback: () => table.moveCellSelection('right'),
      },
      {
        hotkey: 'Shift+ArrowUp',
        callback: () => table.extendCellSelection('up'),
      },
      {
        hotkey: 'Shift+ArrowDown',
        callback: () => table.extendCellSelection('down'),
      },
      {
        hotkey: 'Shift+ArrowLeft',
        callback: () => table.extendCellSelection('left'),
      },
      {
        hotkey: 'Shift+ArrowRight',
        callback: () => table.extendCellSelection('right'),
      },
      { hotkey: 'Mod+A', callback: () => table.selectAllCells() },
      { hotkey: 'Escape', callback: () => table.resetCellSelection(true) },
      {
        hotkey: 'Mod+C',
        callback: () => {
          void navigator.clipboard.writeText(
            toTsv(table.getSelectedCellRangesData()),
          )
        },
      },
    ],
    { target: gridRef },
  )

  return (
    <div className="demo-root">
      <div>
        <button
          className="demo-button demo-button-spaced"
          onClick={() => refreshData()}
        >
          Regenerate Data
        </button>
        <button
          className="demo-button demo-button-spaced"
          onClick={() => stressTest()}
        >
          Stress Test (1K rows)
        </button>
      </div>
      <div className="spacer-sm" />
      <p>
        Click and drag to select a range of cells. Hold Shift while clicking to
        extend the selection, or Ctrl/Cmd to add or subtract a rectangle. Arrow
        keys move the selection, Shift+Arrow extends it, Mod+A selects all,
        Mod+C copies, and Escape clears. Uncomment `enableCellSelection: false`
        on a column def to opt that column out of selection.
      </p>
      <p className="demo-note">
        Hiding, reordering, and pinning columns all keep a live selection
        anchored to the same cell ids. Ranges are indexed in render order, so a
        pinned column moves the rectangle with it rather than splitting it.
      </p>
      <div className="column-toggle-panel">
        <div className="column-toggle-panel-header">
          <label>
            <input
              type="checkbox"
              checked={table.getIsAllColumnsVisible()}
              onChange={table.getToggleAllColumnsVisibilityHandler()}
            />{' '}
            Toggle All
          </label>
        </div>
        {table.getAllLeafColumns().map((column) => (
          <div key={column.id} className="column-toggle-row">
            <label>
              <input
                type="checkbox"
                checked={column.getIsVisible()}
                onChange={column.getToggleVisibilityHandler()}
              />{' '}
              {column.id}
            </label>
          </div>
        ))}
      </div>
      <div className="spacer-sm" />
      <div className="button-row">
        <button
          className="demo-button demo-button-spaced"
          onClick={() => randomizeColumns()}
        >
          Shuffle Columns
        </button>
        <button
          className="demo-button demo-button-spaced"
          onClick={() =>
            table.setColumnOrder(
              [
                ...table.getAllLeafColumns().map((column) => column.id),
              ].reverse(),
            )
          }
        >
          Reverse Column Order
        </button>
        <button
          className="demo-button demo-button-spaced"
          onClick={() => table.resetColumnOrder()}
        >
          Reset Column Order
        </button>
        <button
          className="demo-button demo-button-spaced"
          onClick={() => table.resetColumnPinning()}
        >
          Reset Pinning
        </button>
        <button
          className="demo-button demo-button-spaced"
          onClick={() => table.resetColumnVisibility()}
        >
          Reset Visibility
        </button>
      </div>
      <div className="spacer-sm" />
      <table.Subscribe source={table.atoms.cellSelection}>
        {() => (
          <div>
            {table.getSelectedCellCount().toLocaleString()} cells selected
            across {table.getCellSelectionRowIds().length.toLocaleString()} rows
            and {table.getCellSelectionColumnIds().length} columns
          </div>
        )}
      </table.Subscribe>
      <div className="spacer-sm" />
      <div ref={gridRef} tabIndex={0}>
        <table>
          <thead>
            {table.getHeaderGroups().map((headerGroup) => (
              <tr key={headerGroup.id}>
                {headerGroup.headers.map((header) => {
                  return (
                    <th key={header.id} colSpan={header.colSpan}>
                      {header.isPlaceholder ? null : (
                        <>
                          <button
                            type="button"
                            disabled={!header.column.getCanSort()}
                            className={
                              header.column.getCanSort()
                                ? 'header-button sortable-header'
                                : 'header-button'
                            }
                            onClick={header.column.getToggleSortingHandler()}
                          >
                            <table.FlexRender header={header} />
                            {{ asc: ' 🔼', desc: ' 🔽' }[
                              header.column.getIsSorted() as string
                            ] ?? null}
                          </button>
                          {header.column.getCanPin() && (
                            <div className="pin-actions">
                              {header.column.getIsPinned() !== 'start' ? (
                                <button
                                  className="pin-button"
                                  onClick={() => header.column.pin('start')}
                                >
                                  {'<='}
                                </button>
                              ) : null}
                              {header.column.getIsPinned() ? (
                                <button
                                  className="pin-button"
                                  onClick={() => header.column.pin(false)}
                                >
                                  X
                                </button>
                              ) : null}
                              {header.column.getIsPinned() !== 'end' ? (
                                <button
                                  className="pin-button"
                                  onClick={() => header.column.pin('end')}
                                >
                                  {'=>'}
                                </button>
                              ) : null}
                            </div>
                          )}
                        </>
                      )}
                    </th>
                  )
                })}
              </tr>
            ))}
          </thead>
          <tbody>
            {table.getRowModel().rows.map((row) => (
              // one subscription per row rather than one around the whole
              // tbody, so a drag only re-renders the rows whose key changed
              <table.Subscribe
                key={row.id}
                source={table.atoms.cellSelection}
                selector={(ranges) =>
                  rowSelectionKey(
                    ranges,
                    table.getCellSelectionBounds(),
                    row.getDisplayIndex(),
                    row.id,
                  )
                }
              >
                {() => (
                  <tr>
                    {row.getVisibleCells().map((cell) =>
                      cell.getCanSelect() ? (
                        <td
                          key={cell.id}
                          className={getCellClassName(cell)}
                          tabIndex={cell.getTabIndex()}
                          onMouseDown={cell.getSelectionStartHandler()}
                          onMouseEnter={cell.getSelectionExtendHandler()}
                        >
                          <table.FlexRender cell={cell} />
                        </td>
                      ) : (
                        <td key={cell.id}>
                          <table.FlexRender cell={cell} />
                        </td>
                      ),
                    )}
                  </tr>
                )}
              </table.Subscribe>
            ))}
          </tbody>
          <tfoot>
            <tr>
              <td colSpan={20}>
                Rows ({table.getRowModel().rows.length.toLocaleString()})
              </td>
            </tr>
          </tfoot>
        </table>
      </div>
      <div className="spacer-sm" />
      <div>
        <button
          className="demo-button demo-button-spaced"
          onClick={() =>
            void navigator.clipboard.writeText(
              toTsv(table.getSelectedCellRangesData()),
            )
          }
        >
          Copy Selection
        </button>
        <button
          className="demo-button demo-button-spaced"
          onClick={() => table.selectAllCells()}
        >
          Select All Cells
        </button>
        <button
          className="demo-button demo-button-spaced"
          onClick={() => table.resetCellSelection(true)}
        >
          Clear Selection
        </button>
      </div>
      <hr />
      <br />
      <div>
        <button
          className="demo-button demo-button-spaced"
          onClick={() =>
            console.info(
              'table.getSelectedCellRangesData()',
              table.getSelectedCellRangesData(),
            )
          }
        >
          Log table.getSelectedCellRangesData()
        </button>
      </div>
      <div>
        <label>State:</label>
        <table.Subscribe selector={(state) => state}>
          {(state) => (
            <pre>{data.length < 1_001 && JSON.stringify(state, null, 2)}</pre>
          )}
        </table.Subscribe>
      </div>
      <div>
        <label htmlFor="paste-target">Paste Test:</label>
        {/* scratch area for pasting a copied selection back in, to eyeball
              the tab-separated shape. It sits outside the grid ref, so the
              table hotkeys never intercept typing or Mod+V in here. */}
        <textarea
          id="paste-target"
          className="text-input"
          rows={8}
          placeholder="Copy a selection, then paste here to check the tab-separated output..."
        />
      </div>
    </div>
  )
}

// each cell draws only the sides getSelectionEdges() reports as the boundary of
// the selection, so a union of rectangles gets one continuous outline
/**
 * The narrowest value a row's appearance depends on: whether its own cells fall
 * inside a range, whether the rows immediately above and below do (that decides
 * its top and bottom edges), and whether it owns the focused cell.
 *
 * Rows in the middle of a growing range produce an unchanged key, so <Subscribe>
 * skips re-rendering them. Column layout is deliberately absent: those changes
 * re-render App, which recreates these rows anyway.
 */
function rowSelectionKey(
  ranges: CellSelectionState,
  bounds: Array<CellSelectionBounds>,
  rowIndex: number,
  rowId: string,
) {
  const active = ranges[ranges.length - 1]
  let key =
    ranges.length > 0 && active.anchorRowId === rowId
      ? `f${active.anchorColumnId}`
      : ''

  for (const bound of bounds) {
    const self = rowIndex >= bound.minRowIndex && rowIndex <= bound.maxRowIndex
    const above =
      rowIndex - 1 >= bound.minRowIndex && rowIndex - 1 <= bound.maxRowIndex
    const below =
      rowIndex + 1 >= bound.minRowIndex && rowIndex + 1 <= bound.maxRowIndex

    if (self || above || below) {
      key += `|${self ? 1 : 0}${above ? 1 : 0}${below ? 1 : 0}:${bound.minColumnIndex}-${bound.maxColumnIndex}`
    }
  }

  return key
}

function getCellClassName(cell: Cell<typeof features, Person>) {
  // Most cells in a large grid are unselected, so bail before asking for edges.
  // getSelectionEdges() would otherwise resolve the cell's position a second
  // time just to discover it is not selected.
  if (!cell.getIsSelected()) {
    return cell.getIsFocused()
      ? 'cell-selectable cell-focused'
      : 'cell-selectable'
  }

  const edges = cell.getSelectionEdges()

  return [
    'cell-selectable',
    'cell-selected',
    cell.getIsFocused() && 'cell-focused',
    edges.top && 'cell-edge-top',
    edges.right && 'cell-edge-right',
    edges.bottom && 'cell-edge-bottom',
    edges.left && 'cell-edge-left',
  ]
    .filter(Boolean)
    .join(' ')
}

const rootElement = document.getElementById('root')
if (!rootElement) throw new Error('Failed to find the root element')

ReactDOM.createRoot(rootElement).render(
  <React.StrictMode>
    <App />
    <TanStackDevtools plugins={[tableDevtoolsPlugin()]} />
  </React.StrictMode>,
)

Vue Example: Cell Selection

<script setup lang="ts">
import { ref, useTemplateRef, watch } from 'vue'
import { faker } from '@faker-js/faker'
import { useTanStackTableDevtools } from '@tanstack/vue-table-devtools'
import { useHotkeys } from '@tanstack/vue-hotkeys'
import {
  FlexRender,
  cellSelectionFeature,
  columnOrderingFeature,
  columnPinningFeature,
  columnVisibilityFeature,
  createColumnHelper,
  createSortedRowModel,
  rowSortingFeature,
  sortFn_alphanumeric,
  sortFn_datetime,
  sortFn_text,
  tableFeatures,
  useTable,
} from '@tanstack/vue-table'
import { makeData } from './makeData'
import type { Cell } from '@tanstack/vue-table'
import type { Person } from './makeData'

const features = tableFeatures({
  cellSelectionFeature,
  columnOrderingFeature,
  columnPinningFeature,
  columnVisibilityFeature,
  rowSortingFeature,
  sortedRowModel: createSortedRowModel(),
  sortFns: {
    alphanumeric: sortFn_alphanumeric,
    datetime: sortFn_datetime,
    text: sortFn_text,
  },
})

const columnHelper = createColumnHelper<typeof features, Person>()

// Serializing a selection for the clipboard is a userland concern: the table
// hands back `getSelectedCellRangesData()` as raw values, and the delimiter,
// the null representation, and the quoting rules are all yours to pick. This is
// the spreadsheet-flavored version.
function escapeTsvValue(value: unknown) {
  const text = value == null ? '' : String(value)
  const safeText =
    typeof value === 'string' && /^[\t\r ]*[=+@-]/.test(value)
      ? `'${text}`
      : text

  // spreadsheets expect a field to be quoted once it contains a delimiter, a
  // newline, or a quote, with inner quotes doubled
  return /["\t\n\r]/.test(safeText)
    ? `"${safeText.replace(/"/g, '""')}"`
    : safeText
}

function toTsv(ranges: Array<Array<Array<unknown>>>) {
  return ranges
    .map((grid) =>
      grid.map((row) => row.map(escapeTsvValue).join('\t')).join('\n'),
    )
    .join('\n\n') // blank line between final selected regions
}

function getCellClassName(cell: Cell<typeof features, Person>) {
  // Most cells in a large grid are unselected, so bail before asking for edges.
  // getSelectionEdges() would otherwise resolve the cell's position a second
  // time just to discover it is not selected.
  if (!cell.getIsSelected()) {
    return cell.getIsFocused()
      ? 'cell-selectable cell-focused'
      : 'cell-selectable'
  }

  const edges = cell.getSelectionEdges()

  return [
    'cell-selectable',
    'cell-selected',
    cell.getIsFocused() && 'cell-focused',
    edges.top && 'cell-edge-top',
    edges.right && 'cell-edge-right',
    edges.bottom && 'cell-edge-bottom',
    edges.left && 'cell-edge-left',
  ]
    .filter(Boolean)
    .join(' ')
}

const columns = columnHelper.columns([
  columnHelper.accessor('firstName', {
    header: 'First Name',
    cell: (info) => info.getValue(),
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor((row) => row.lastName, {
    id: 'lastName',
    header: () => 'Last Name',
    cell: (info) => info.getValue(),
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('age', {
    header: () => 'Age',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('visits', {
    header: () => 'Visits',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('status', {
    header: 'Status',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('progress', {
    header: 'Profile Progress',
    // enableCellSelection: false, // this column opts out of cell selection
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('email', {
    header: 'Email',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('phone', {
    header: 'Phone',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('city', {
    header: 'City',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('country', {
    header: 'Country',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('department', {
    header: 'Department',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('salary', {
    header: 'Salary',
    cell: (info) => info.getValue().toLocaleString(),
    footer: (props) => props.column.id,
  }),
])

const data = ref(makeData(20))
const refreshData = () => (data.value = makeData(20))
const stressTest = () => (data.value = makeData(1_000))

const table = useTable({
  key: 'cell-selection', // needed for devtools
  features,
  data,
  columns,
  getRowId: (row: Person) => row.id,
  enableCellSelection: true, // enable cell selection for all cells
  // initialState: { cellSelection: [] }, // select cells on first render
  // state: { cellSelection }, // classic controlled state; pair with onCellSelectionChange
  // onCellSelectionChange: setCellSelection,
  // enableCellRangeSelection: false, // disable Shift-click and drag ranges; default true
  // enableMultiCellRangeSelection: false, // allow only one rectangle at a time; default true
  // enableCellSelectionDrag: false, // disable drag-to-select; default true
  // isCellRangeSelectionEvent: event => Boolean(event.metaKey), // use Meta instead of Shift
  debugTable: true,
})

useTanStackTableDevtools(table)

const copySelection = () =>
  void navigator.clipboard.writeText(toTsv(table.getSelectedCellRangesData()))

const logRangesData = () =>
  console.info(
    'table.getSelectedCellRangesData()',
    table.getSelectedCellRangesData(),
  )

const randomizeColumns = () => {
  table.setColumnOrder(
    faker.helpers.shuffle(table.getAllLeafColumns().map((d) => d.id)),
  )
}

// optionally, reset the cellSelection state not only when data changes, but also
// when column order, pinning, visibility, or sorting changes
// customize this to your needs
watch(
  () => [
    table.atoms.columnOrder.get(),
    table.atoms.columnPinning.get(),
    table.atoms.columnVisibility.get(),
    table.atoms.sorting.get(),
  ],
  () => table.resetCellSelection(true),
)

const gridRef = useTemplateRef<HTMLDivElement>('grid')

// keyboard navigation is TanStack Hotkeys driving the table's imperative APIs;
// table-core ships no keydown handling of its own
useHotkeys(
  [
    { hotkey: 'ArrowUp', callback: () => table.moveCellSelection('up') },
    { hotkey: 'ArrowDown', callback: () => table.moveCellSelection('down') },
    { hotkey: 'ArrowLeft', callback: () => table.moveCellSelection('left') },
    { hotkey: 'ArrowRight', callback: () => table.moveCellSelection('right') },
    {
      hotkey: 'Shift+ArrowUp',
      callback: () => table.extendCellSelection('up'),
    },
    {
      hotkey: 'Shift+ArrowDown',
      callback: () => table.extendCellSelection('down'),
    },
    {
      hotkey: 'Shift+ArrowLeft',
      callback: () => table.extendCellSelection('left'),
    },
    {
      hotkey: 'Shift+ArrowRight',
      callback: () => table.extendCellSelection('right'),
    },
    { hotkey: 'Mod+A', callback: () => table.selectAllCells() },
    { hotkey: 'Escape', callback: () => table.resetCellSelection(true) },
    {
      hotkey: 'Mod+C',
      callback: () => {
        void navigator.clipboard.writeText(
          toTsv(table.getSelectedCellRangesData()),
        )
      },
    },
  ],
  { target: gridRef },
)
</script>

<template>
  <div class="demo-root">
    <div>
      <button class="demo-button demo-button-spaced" @click="refreshData">
        Regenerate Data
      </button>
      <button class="demo-button demo-button-spaced" @click="stressTest">
        Stress Test (1K rows)
      </button>
    </div>
    <div class="spacer-sm" />
    <p>
      Click and drag to select a range of cells. Hold Shift while clicking to
      extend the selection, or Ctrl/Cmd to add or subtract a rectangle. Arrow
      keys move the selection, Shift+Arrow extends it, Mod+A selects all, Mod+C
      copies, and Escape clears. Uncomment `enableCellSelection: false` on a
      column def to opt that column out of selection.
    </p>
    <p class="demo-note">
      Hiding, reordering, and pinning columns all keep a live selection anchored
      to the same cell ids. Ranges are indexed in render order, so a pinned
      column moves the rectangle with it rather than splitting it.
    </p>
    <div class="column-toggle-panel">
      <div class="column-toggle-panel-header">
        <label>
          <input
            type="checkbox"
            :checked="table.getIsAllColumnsVisible()"
            @change="table.getToggleAllColumnsVisibilityHandler()($event)"
          />
          Toggle All
        </label>
      </div>
      <div
        v-for="column in table.getAllLeafColumns()"
        :key="column.id"
        class="column-toggle-row"
      >
        <label>
          <input
            type="checkbox"
            :checked="column.getIsVisible()"
            @change="column.getToggleVisibilityHandler()($event)"
          />
          {{ column.id }}
        </label>
      </div>
    </div>
    <div class="spacer-sm" />
    <div class="button-row">
      <button class="demo-button demo-button-spaced" @click="randomizeColumns">
        Shuffle Columns
      </button>
      <button
        class="demo-button demo-button-spaced"
        @click="
          table.setColumnOrder(
            [...table.getAllLeafColumns().map((column) => column.id)].reverse(),
          )
        "
      >
        Reverse Column Order
      </button>
      <button
        class="demo-button demo-button-spaced"
        @click="table.resetColumnOrder()"
      >
        Reset Column Order
      </button>
      <button
        class="demo-button demo-button-spaced"
        @click="table.resetColumnPinning()"
      >
        Reset Pinning
      </button>
      <button
        class="demo-button demo-button-spaced"
        @click="table.resetColumnVisibility()"
      >
        Reset Visibility
      </button>
    </div>
    <div class="spacer-sm" />
    <!--
      Vue tracks atom reads natively, so this count re-evaluates on its own.
      There is no equivalent of React's per-row Subscribe to reach for here.
    -->
    <div>
      {{ table.getSelectedCellCount().toLocaleString() }} cells selected across
      {{ table.getCellSelectionRowIds().length.toLocaleString() }} rows and
      {{ table.getCellSelectionColumnIds().length }} columns
    </div>
    <div class="spacer-sm" />
    <div ref="grid" tabindex="0">
      <table>
        <thead>
          <tr
            v-for="headerGroup in table.getHeaderGroups()"
            :key="headerGroup.id"
          >
            <th
              v-for="header in headerGroup.headers"
              :key="header.id"
              :colSpan="header.colSpan"
            >
              <template v-if="!header.isPlaceholder">
                <button
                  type="button"
                  :disabled="!header.column.getCanSort()"
                  :class="
                    header.column.getCanSort()
                      ? 'header-button sortable-header'
                      : 'header-button'
                  "
                  @click="header.column.getToggleSortingHandler()?.($event)"
                >
                  <FlexRender :header="header" />
                  {{
                    { asc: ' 🔼', desc: ' 🔽' }[
                      header.column.getIsSorted() as string
                    ] ?? ''
                  }}
                </button>
                <div v-if="header.column.getCanPin()" class="pin-actions">
                  <button
                    v-if="header.column.getIsPinned() !== 'start'"
                    class="pin-button"
                    @click="header.column.pin('start')"
                  >
                    {{ '<=' }}
                  </button>
                  <button
                    v-if="header.column.getIsPinned()"
                    class="pin-button"
                    @click="header.column.pin(false)"
                  >
                    X
                  </button>
                  <button
                    v-if="header.column.getIsPinned() !== 'end'"
                    class="pin-button"
                    @click="header.column.pin('end')"
                  >
                    {{ '=>' }}
                  </button>
                </div>
              </template>
            </th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="row in table.getRowModel().rows" :key="row.id">
            <template v-for="cell in row.getVisibleCells()" :key="cell.id">
              <td
                v-if="cell.getCanSelect()"
                :class="getCellClassName(cell)"
                :tabindex="cell.getTabIndex()"
                @mousedown="cell.getSelectionStartHandler()($event)"
                @mouseenter="cell.getSelectionExtendHandler()($event)"
              >
                <FlexRender :cell="cell" />
              </td>
              <td v-else>
                <FlexRender :cell="cell" />
              </td>
            </template>
          </tr>
        </tbody>
        <tfoot>
          <tr>
            <td :colSpan="20">
              Rows ({{ table.getRowModel().rows.length.toLocaleString() }})
            </td>
          </tr>
        </tfoot>
      </table>
    </div>
    <div class="spacer-sm" />
    <div>
      <button class="demo-button demo-button-spaced" @click="copySelection">
        Copy Selection
      </button>
      <button
        class="demo-button demo-button-spaced"
        @click="table.selectAllCells()"
      >
        Select All Cells
      </button>
      <button
        class="demo-button demo-button-spaced"
        @click="table.resetCellSelection(true)"
      >
        Clear Selection
      </button>
    </div>
    <hr />
    <br />
    <div>
      <button class="demo-button demo-button-spaced" @click="logRangesData">
        Log table.getSelectedCellRangesData()
      </button>
    </div>
    <div>
      <label>State:</label>
      <pre>{{
        data.length < 1_001 ? JSON.stringify(table.store.get(), null, 2) : ''
      }}</pre>
    </div>
    <div>
      <label for="paste-target">Paste Test:</label>
      <!--
        scratch area for pasting a copied selection back in, to eyeball the
        tab-separated shape. It sits outside the grid ref, so the table hotkeys
        never intercept typing or Mod+V in here.
      -->
      <textarea
        id="paste-target"
        class="text-input"
        :rows="8"
        placeholder="Copy a selection, then paste here to check the tab-separated output..."
      />
    </div>
  </div>
</template>
<script setup lang="ts">
import { ref, useTemplateRef, watch } from 'vue'
import { faker } from '@faker-js/faker'
import { useTanStackTableDevtools } from '@tanstack/vue-table-devtools'
import { useHotkeys } from '@tanstack/vue-hotkeys'
import {
  FlexRender,
  cellSelectionFeature,
  columnOrderingFeature,
  columnPinningFeature,
  columnVisibilityFeature,
  createColumnHelper,
  createSortedRowModel,
  rowSortingFeature,
  sortFn_alphanumeric,
  sortFn_datetime,
  sortFn_text,
  tableFeatures,
  useTable,
} from '@tanstack/vue-table'
import { makeData } from './makeData'
import type { Cell } from '@tanstack/vue-table'
import type { Person } from './makeData'

const features = tableFeatures({
  cellSelectionFeature,
  columnOrderingFeature,
  columnPinningFeature,
  columnVisibilityFeature,
  rowSortingFeature,
  sortedRowModel: createSortedRowModel(),
  sortFns: {
    alphanumeric: sortFn_alphanumeric,
    datetime: sortFn_datetime,
    text: sortFn_text,
  },
})

const columnHelper = createColumnHelper<typeof features, Person>()

// Serializing a selection for the clipboard is a userland concern: the table
// hands back `getSelectedCellRangesData()` as raw values, and the delimiter,
// the null representation, and the quoting rules are all yours to pick. This is
// the spreadsheet-flavored version.
function escapeTsvValue(value: unknown) {
  const text = value == null ? '' : String(value)
  const safeText =
    typeof value === 'string' && /^[\t\r ]*[=+@-]/.test(value)
      ? `'${text}`
      : text

  // spreadsheets expect a field to be quoted once it contains a delimiter, a
  // newline, or a quote, with inner quotes doubled
  return /["\t\n\r]/.test(safeText)
    ? `"${safeText.replace(/"/g, '""')}"`
    : safeText
}

function toTsv(ranges: Array<Array<Array<unknown>>>) {
  return ranges
    .map((grid) =>
      grid.map((row) => row.map(escapeTsvValue).join('\t')).join('\n'),
    )
    .join('\n\n') // blank line between final selected regions
}

function getCellClassName(cell: Cell<typeof features, Person>) {
  // Most cells in a large grid are unselected, so bail before asking for edges.
  // getSelectionEdges() would otherwise resolve the cell's position a second
  // time just to discover it is not selected.
  if (!cell.getIsSelected()) {
    return cell.getIsFocused()
      ? 'cell-selectable cell-focused'
      : 'cell-selectable'
  }

  const edges = cell.getSelectionEdges()

  return [
    'cell-selectable',
    'cell-selected',
    cell.getIsFocused() && 'cell-focused',
    edges.top && 'cell-edge-top',
    edges.right && 'cell-edge-right',
    edges.bottom && 'cell-edge-bottom',
    edges.left && 'cell-edge-left',
  ]
    .filter(Boolean)
    .join(' ')
}

const columns = columnHelper.columns([
  columnHelper.accessor('firstName', {
    header: 'First Name',
    cell: (info) => info.getValue(),
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor((row) => row.lastName, {
    id: 'lastName',
    header: () => 'Last Name',
    cell: (info) => info.getValue(),
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('age', {
    header: () => 'Age',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('visits', {
    header: () => 'Visits',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('status', {
    header: 'Status',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('progress', {
    header: 'Profile Progress',
    // enableCellSelection: false, // this column opts out of cell selection
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('email', {
    header: 'Email',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('phone', {
    header: 'Phone',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('city', {
    header: 'City',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('country', {
    header: 'Country',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('department', {
    header: 'Department',
    footer: (props) => props.column.id,
  }),
  columnHelper.accessor('salary', {
    header: 'Salary',
    cell: (info) => info.getValue().toLocaleString(),
    footer: (props) => props.column.id,
  }),
])

const data = ref(makeData(20))
const refreshData = () => (data.value = makeData(20))
const stressTest = () => (data.value = makeData(1_000))

const table = useTable({
  key: 'cell-selection', // needed for devtools
  features,
  data,
  columns,
  getRowId: (row: Person) => row.id,
  enableCellSelection: true, // enable cell selection for all cells
  // initialState: { cellSelection: [] }, // select cells on first render
  // state: { cellSelection }, // classic controlled state; pair with onCellSelectionChange
  // onCellSelectionChange: setCellSelection,
  // enableCellRangeSelection: false, // disable Shift-click and drag ranges; default true
  // enableMultiCellRangeSelection: false, // allow only one rectangle at a time; default true
  // enableCellSelectionDrag: false, // disable drag-to-select; default true
  // isCellRangeSelectionEvent: event => Boolean(event.metaKey), // use Meta instead of Shift
  debugTable: true,
})

useTanStackTableDevtools(table)

const copySelection = () =>
  void navigator.clipboard.writeText(toTsv(table.getSelectedCellRangesData()))

const logRangesData = () =>
  console.info(
    'table.getSelectedCellRangesData()',
    table.getSelectedCellRangesData(),
  )

const randomizeColumns = () => {
  table.setColumnOrder(
    faker.helpers.shuffle(table.getAllLeafColumns().map((d) => d.id)),
  )
}

// optionally, reset the cellSelection state not only when data changes, but also
// when column order, pinning, visibility, or sorting changes
// customize this to your needs
watch(
  () => [
    table.atoms.columnOrder.get(),
    table.atoms.columnPinning.get(),
    table.atoms.columnVisibility.get(),
    table.atoms.sorting.get(),
  ],
  () => table.resetCellSelection(true),
)

const gridRef = useTemplateRef<HTMLDivElement>('grid')

// keyboard navigation is TanStack Hotkeys driving the table's imperative APIs;
// table-core ships no keydown handling of its own
useHotkeys(
  [
    { hotkey: 'ArrowUp', callback: () => table.moveCellSelection('up') },
    { hotkey: 'ArrowDown', callback: () => table.moveCellSelection('down') },
    { hotkey: 'ArrowLeft', callback: () => table.moveCellSelection('left') },
    { hotkey: 'ArrowRight', callback: () => table.moveCellSelection('right') },
    {
      hotkey: 'Shift+ArrowUp',
      callback: () => table.extendCellSelection('up'),
    },
    {
      hotkey: 'Shift+ArrowDown',
      callback: () => table.extendCellSelection('down'),
    },
    {
      hotkey: 'Shift+ArrowLeft',
      callback: () => table.extendCellSelection('left'),
    },
    {
      hotkey: 'Shift+ArrowRight',
      callback: () => table.extendCellSelection('right'),
    },
    { hotkey: 'Mod+A', callback: () => table.selectAllCells() },
    { hotkey: 'Escape', callback: () => table.resetCellSelection(true) },
    {
      hotkey: 'Mod+C',
      callback: () => {
        void navigator.clipboard.writeText(
          toTsv(table.getSelectedCellRangesData()),
        )
      },
    },
  ],
  { target: gridRef },
)
</script>

<template>
  <div class="demo-root">
    <div>
      <button class="demo-button demo-button-spaced" @click="refreshData">
        Regenerate Data
      </button>
      <button class="demo-button demo-button-spaced" @click="stressTest">
        Stress Test (1K rows)
      </button>
    </div>
    <div class="spacer-sm" />
    <p>
      Click and drag to select a range of cells. Hold Shift while clicking to
      extend the selection, or Ctrl/Cmd to add or subtract a rectangle. Arrow
      keys move the selection, Shift+Arrow extends it, Mod+A selects all, Mod+C
      copies, and Escape clears. Uncomment `enableCellSelection: false` on a
      column def to opt that column out of selection.
    </p>
    <p class="demo-note">
      Hiding, reordering, and pinning columns all keep a live selection anchored
      to the same cell ids. Ranges are indexed in render order, so a pinned
      column moves the rectangle with it rather than splitting it.
    </p>
    <div class="column-toggle-panel">
      <div class="column-toggle-panel-header">
        <label>
          <input
            type="checkbox"
            :checked="table.getIsAllColumnsVisible()"
            @change="table.getToggleAllColumnsVisibilityHandler()($event)"
          />
          Toggle All
        </label>
      </div>
      <div
        v-for="column in table.getAllLeafColumns()"
        :key="column.id"
        class="column-toggle-row"
      >
        <label>
          <input
            type="checkbox"
            :checked="column.getIsVisible()"
            @change="column.getToggleVisibilityHandler()($event)"
          />
          {{ column.id }}
        </label>
      </div>
    </div>
    <div class="spacer-sm" />
    <div class="button-row">
      <button class="demo-button demo-button-spaced" @click="randomizeColumns">
        Shuffle Columns
      </button>
      <button
        class="demo-button demo-button-spaced"
        @click="
          table.setColumnOrder(
            [...table.getAllLeafColumns().map((column) => column.id)].reverse(),
          )
        "
      >
        Reverse Column Order
      </button>
      <button
        class="demo-button demo-button-spaced"
        @click="table.resetColumnOrder()"
      >
        Reset Column Order
      </button>
      <button
        class="demo-button demo-button-spaced"
        @click="table.resetColumnPinning()"
      >
        Reset Pinning
      </button>
      <button
        class="demo-button demo-button-spaced"
        @click="table.resetColumnVisibility()"
      >
        Reset Visibility
      </button>
    </div>
    <div class="spacer-sm" />
    <!--
      Vue tracks atom reads natively, so this count re-evaluates on its own.
      There is no equivalent of React's per-row Subscribe to reach for here.
    -->
    <div>
      {{ table.getSelectedCellCount().toLocaleString() }} cells selected across
      {{ table.getCellSelectionRowIds().length.toLocaleString() }} rows and
      {{ table.getCellSelectionColumnIds().length }} columns
    </div>
    <div class="spacer-sm" />
    <div ref="grid" tabindex="0">
      <table>
        <thead>
          <tr
            v-for="headerGroup in table.getHeaderGroups()"
            :key="headerGroup.id"
          >
            <th
              v-for="header in headerGroup.headers"
              :key="header.id"
              :colSpan="header.colSpan"
            >
              <template v-if="!header.isPlaceholder">
                <button
                  type="button"
                  :disabled="!header.column.getCanSort()"
                  :class="
                    header.column.getCanSort()
                      ? 'header-button sortable-header'
                      : 'header-button'
                  "
                  @click="header.column.getToggleSortingHandler()?.($event)"
                >
                  <FlexRender :header="header" />
                  {{
                    { asc: ' 🔼', desc: ' 🔽' }[
                      header.column.getIsSorted() as string
                    ] ?? ''
                  }}
                </button>
                <div v-if="header.column.getCanPin()" class="pin-actions">
                  <button
                    v-if="header.column.getIsPinned() !== 'start'"
                    class="pin-button"
                    @click="header.column.pin('start')"
                  >
                    {{ '<=' }}
                  </button>
                  <button
                    v-if="header.column.getIsPinned()"
                    class="pin-button"
                    @click="header.column.pin(false)"
                  >
                    X
                  </button>
                  <button
                    v-if="header.column.getIsPinned() !== 'end'"
                    class="pin-button"
                    @click="header.column.pin('end')"
                  >
                    {{ '=>' }}
                  </button>
                </div>
              </template>
            </th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="row in table.getRowModel().rows" :key="row.id">
            <template v-for="cell in row.getVisibleCells()" :key="cell.id">
              <td
                v-if="cell.getCanSelect()"
                :class="getCellClassName(cell)"
                :tabindex="cell.getTabIndex()"
                @mousedown="cell.getSelectionStartHandler()($event)"
                @mouseenter="cell.getSelectionExtendHandler()($event)"
              >
                <FlexRender :cell="cell" />
              </td>
              <td v-else>
                <FlexRender :cell="cell" />
              </td>
            </template>
          </tr>
        </tbody>
        <tfoot>
          <tr>
            <td :colSpan="20">
              Rows ({{ table.getRowModel().rows.length.toLocaleString() }})
            </td>
          </tr>
        </tfoot>
      </table>
    </div>
    <div class="spacer-sm" />
    <div>
      <button class="demo-button demo-button-spaced" @click="copySelection">
        Copy Selection
      </button>
      <button
        class="demo-button demo-button-spaced"
        @click="table.selectAllCells()"
      >
        Select All Cells
      </button>
      <button
        class="demo-button demo-button-spaced"
        @click="table.resetCellSelection(true)"
      >
        Clear Selection
      </button>
    </div>
    <hr />
    <br />
    <div>
      <button class="demo-button demo-button-spaced" @click="logRangesData">
        Log table.getSelectedCellRangesData()
      </button>
    </div>
    <div>
      <label>State:</label>
      <pre>{{
        data.length < 1_001 ? JSON.stringify(table.store.get(), null, 2) : ''
      }}</pre>
    </div>
    <div>
      <label for="paste-target">Paste Test:</label>
      <!--
        scratch area for pasting a copied selection back in, to eyeball the
        tab-separated shape. It sits outside the grid ref, so the table hotkeys
        never intercept typing or Mod+V in here.
      -->
      <textarea
        id="paste-target"
        class="text-input"
        :rows="8"
        placeholder="Copy a selection, then paste here to check the tab-separated output..."
      />
    </div>
  </div>
</template>